//---------------------------------------------------------------------------
#pragma hdrstop
#include "ChipFunctions.h"      //      
#include "MainProgram.h"        //      
#include "FormFunctions.h"      //      
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
chip  SelectedChip;     //  
//---------------------------------------------------------------------------
//---       ------------------------
//---------------------------------------------------------------------------
void InitChip(unsigned char FamilyCode)
{ //   

  switch(FamilyCode)
  { case 0x0:   //    (    ROM)
                switch(SelectedChip.Modify)             //    
                { case 1:  SendMsgToLogForm(220);       //   RW1990
                           SelectedChip.Name            = "RW1990";     //  
                           SelectedChip.ImageName       = "img_03.jpg"; //    
                           SelectedChip.Family          = 0x0;          //   (  ,    ROM )
                           SelectedChip.Area1Start      = 0;            //                                      Area1=not used
                           SelectedChip.Area1Size       = 0;            //
                           SelectedChip.Area2Start      = 0;            //                                      Area2=not used
                           SelectedChip.Area2Size       = 0;            //
                           SelectedChip.Area3Start      = 0;            //                                      Area3=not used
                           SelectedChip.Area3Size       = 0;            //
                           SelectedChip.Area4Start      = 0;            //                                      Area4=not used
                           SelectedChip.Area4Size       = 0;            //
                           break;
                  default: break;
                }
                break;
    case 0x2:   SendMsgToLogForm(205);          //   DS1991
                SelectedChip.Name               = "DS1991";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x02;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                Area1=Key1 (subkey 00, start address 00 000000)
                SelectedChip.Area1Size          = 64;           //  
                SelectedChip.Area2Start         = 0x40;         //                                      Area2=Key2 (subkey 01, start sddress 01 000000)
                SelectedChip.Area2Size          = 64;           //
                SelectedChip.Area3Start         = 0x80;         //                                      Area3=Key3 (subkey 10, start address 10 000000)
                SelectedChip.Area3Size          = 64;           //
                SelectedChip.Area4Start         = 0xC0;         //                                      Area4=Scratchpad (subkey 11, start address 11 000000)
                SelectedChip.Area4Size          = 64;           //
                break;
    case 0x4:   SendMsgToLogForm(215);          //   DS1994
                SelectedChip.Name               = "DS1994";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x04;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //   
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0x200;        //   timekeeping registers
                SelectedChip.Area2Size          = 32;           //  timekeeping registers
                SelectedChip.Area3Start         = 0x0;          //   
                SelectedChip.Area3Size          = 32;           //  
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x5:   SendMsgToLogForm(211);          //   DS2405
                SelectedChip.Name               = "DS2405";     //  
                SelectedChip.ImageName          = "img_04.jpg"; //    
                SelectedChip.Family             = 0x05;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //      ,  ROM
                SelectedChip.Area1Size          = 0;            //
                SelectedChip.Area2Start         = 0;            //
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x6:   SendMsgToLogForm(208);          //   DS1993
                SelectedChip.Name               = "DS1993";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x6;          //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0;            //           Area2=Scratchpad
                SelectedChip.Area2Size          = 32;           //  
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x8:   SendMsgToLogForm(207);          //   DS1992
                SelectedChip.Name               = "DS1992";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x8;          //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 128;          //  
                SelectedChip.Area2Start         = 0;            //           Area2=Scratchpad
                SelectedChip.Area2Size          = 32;           //  
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0xA:   SendMsgToLogForm(209);          //   DS1995
                SelectedChip.Name               = "DS1995";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0xA;          //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 2048;         //  
                SelectedChip.Area2Start         = 0;            //           Area2=Scratchpad
                SelectedChip.Area2Size          = 32;           //  
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0xC:   SendMsgToLogForm(210);          //   DS1996
                SelectedChip.Name               = "DS1996";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0xC;          //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 8192;         //  
                SelectedChip.Area2Start         = 0;            //           Area2=Scratchpad
                SelectedChip.Area2Size          = 32;           //  
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x10:  SendMsgToLogForm(200);          //   DS18S20
                SelectedChip.Name               = "DS18S20";    //  
                SelectedChip.ImageName          = "img_02.jpg"; //    
                SelectedChip.Family             = 0x10;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                Area1=Scratchpad
                SelectedChip.Area1Size          = 8;            //  
                SelectedChip.Area2Start         = 0;            //                                      Area2=not used
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x14:  SendMsgToLogForm(201);          //   DS2430A
                SelectedChip.Name               = "DS2430A";    //  
                SelectedChip.ImageName          = "img_01.jpg"; //    
                SelectedChip.Family             = 0x14;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 32;           //  
                SelectedChip.Area2Start         = 0;            //          Area2=Data Scratchpad
                SelectedChip.Area2Size          = 32;           //   
                SelectedChip.Area3Start         = 0;            //               Area3=Application Register / Application Register Scratchpad
                SelectedChip.Area3Size          = 8;            //  
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x1A:  SendMsgToLogForm(216);          //   DS1963L
                SelectedChip.Name               = "DS1963L";    //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x1A;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0;            //          Area2=Data Scratchpad
                SelectedChip.Area2Size          = 32;           //   
                SelectedChip.Area3Start         = 0;            //               Area3=Counters
                SelectedChip.Area3Size          = 16;           //  
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x1D:  SendMsgToLogForm(217);          //   DS2423
                SelectedChip.Name               = "DS2423";     //  
                SelectedChip.ImageName          = "img_07.jpg"; //    
                SelectedChip.Family             = 0x1D;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0;            //          Area2=Data Scratchpad
                SelectedChip.Area2Size          = 32;           //   
                SelectedChip.Area3Start         = 0;            //               Area3=Counters
                SelectedChip.Area3Size          = 16;           //  
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x22:  SendMsgToLogForm(212);          //   DS1822
                SelectedChip.Name               = "DS1822";     //  
                SelectedChip.ImageName          = "img_02.jpg"; //    
                SelectedChip.Family             = 0x22;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                Area1=Scratchpad
                SelectedChip.Area1Size          = 8;            //  
                SelectedChip.Area2Start         = 0;            //                                      Area2=not used
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x23:  SendMsgToLogForm(202);          //   DS24B33
                SelectedChip.Name               = "DS24B33";    //  
                SelectedChip.ImageName          = "img_01.jpg"; //    
                SelectedChip.Family             = 0x23;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0;            //           Area2=Scratchpad
                SelectedChip.Area2Size          = 32;           //  
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x24:  SendMsgToLogForm(213);          //   DS2415
                SelectedChip.Name               = "DS2415";     //  
                SelectedChip.ImageName          = "img_05.jpg"; //    
                SelectedChip.Family             = 0x24;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Control Byte + 4 Bytes Counter
                SelectedChip.Area1Size          = 8;            //  
                SelectedChip.Area2Start         = 0;            //                                      Area2=not used
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x27:  SendMsgToLogForm(213);          //   DS2417
                SelectedChip.Name               = "DS2417";     //  
                SelectedChip.ImageName          = "img_06.jpg"; //    
                SelectedChip.Family             = 0x27;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Control Byte + 4 Bytes Counter
                SelectedChip.Area1Size          = 8;            //  
                SelectedChip.Area2Start         = 0;            //                                      Area2=not used
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x28:  SendMsgToLogForm(203);          //   DS18B20
                SelectedChip.Name               = "DS18B20";    //  
                SelectedChip.ImageName          = "img_02.jpg"; //    
                SelectedChip.Family             = 0x28;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                Area1=Scratchpad
                SelectedChip.Area1Size          = 8;            //  
                SelectedChip.Area2Start         = 0;            //                                      Area2=not used
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //                                      Area3=not used
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x2C:  SendMsgToLogForm(219);          //   DS2890
                SelectedChip.Name               = "DS2890";     //  
                SelectedChip.ImageName          = "img_08.jpg"; //    
                SelectedChip.Family             = 0x2C;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //      ,  ROM
                SelectedChip.Area1Size          = 0;            //
                SelectedChip.Area2Start         = 0;            //
                SelectedChip.Area2Size          = 0;            //
                SelectedChip.Area3Start         = 0;            //
                SelectedChip.Area3Size          = 0;            //
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x2D:  SendMsgToLogForm(204);          //   DS2431
                SelectedChip.Name               = "DS2431";     //  
                SelectedChip.ImageName          = "img_01.jpg"; //    
                SelectedChip.Family             = 0x2D;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                  Area1=Data
                SelectedChip.Area1Size          = 128;          //  
                SelectedChip.Area2Start         = 0x80;         //          Area2=Registers
                SelectedChip.Area2Size          = 8;            //   
                SelectedChip.Area3Start         = 0;            //                Area3=Scratchpad
                SelectedChip.Area3Size          = 8;            //  
                SelectedChip.Area4Start         = 0;            //                                      Area4=not used
                SelectedChip.Area4Size          = 0;            //
                break;
    case 0x82:  SendMsgToLogForm(206);          //   DS1425
                SelectedChip.Name               = "DS1425";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x82;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //                Area1=Key1 (subkey 00, start address 00 000000)
                SelectedChip.Area1Size          = 64;           //  
                SelectedChip.Area2Start         = 0x40;         //                                      Area2=Key2 (subkey 01, start sddress 01 000000)
                SelectedChip.Area2Size          = 64;           //
                SelectedChip.Area3Start         = 0x80;         //                                      Area3=Key3 (subkey 10, start address 10 000000)
                SelectedChip.Area3Size          = 64;           //
                SelectedChip.Area4Start         = 0xC0;         //                                      Area4=Scratchpad (subkey 11, start address 11 000000)
                SelectedChip.Area4Size          = 64;           //
                break;
    case 0x84:  SendMsgToLogForm(218);          //   DS1427
                SelectedChip.Name               = "DS1427";     //  
                SelectedChip.ImageName          = "img_03.jpg"; //    
                SelectedChip.Family             = 0x84;         //   (  ,    ROM )
                SelectedChip.Area1Start         = 0;            //   
                SelectedChip.Area1Size          = 512;          //  
                SelectedChip.Area2Start         = 0x200;        //   timekeeping registers
                SelectedChip.Area2Size          = 32;           //  timekeeping registers
                SelectedChip.Area3Start         = 0x0;          //   
                SelectedChip.Area3Size          = 32;           //  
                SelectedChip.Area4Start         = 0;            //
                SelectedChip.Area4Size          = 0;            //
                break;
    default:    break;
  }
  //    
  InitArea(1); InitArea(2); InitArea(3); InitArea(4);
}
//---------------------------------------------------------------------------
//---     --------------------------------
//---------------------------------------------------------------------------
void InitArea(unsigned int Number)
{ switch(Number)
  { case 1:  //  FF-  1
             for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
             { SelectedChip.Area1[i]=0xFF; }
             break;
    case 2:  //  FF-  2
             for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
             { SelectedChip.Area2[i]=0xFF; }
             break;
    case 3:  //  FF-  3
             for(unsigned int i=0; i<SelectedChip.Area3Size; i++)
             { SelectedChip.Area3[i]=0xFF; }
             break;
    case 4:  //  FF-  4
             for(unsigned int i=0; i<SelectedChip.Area4Size; i++)
             { SelectedChip.Area4[i]=0xFF; }
             break;
    default: break;
  }
}
//---------------------------------------------------------------------------
//---    BIN-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromBinFileToMemory(AnsiString FilePath)
{ TFileStream* fs;              //    
  unsigned char rffch[1];       //     

  SendMsgToLogForm(22);         //    BIN-  
  //    bin-       
  switch(SelectedChip.Family)
  { case 0x0:   //    (    ROM)
                switch(SelectedChip.Modify)
                { case 1:  //    RW1990
                           fs=new TFileStream(FilePath,fmOpenRead);//    
                           for(unsigned int i=0; i<8; i++)         //  ROM
                           { if(fs->Read(rffch,1))                 //    
                             { SelectedChip.ROM[i]=rffch[0];       //    
                             }
                           }
                           delete fs;                              //   
                           Form1->StaticText1->Caption=FilePath;   //    
                           //       ROM  
                           PlaceDataToForm(0,0);                   //   ROM  Edit3 (    )
                           break;
                  default: break;
                }
                break;
    case 0x5:   //   DS2405
    case 0x2C:  //   DS2890
                SendMsgToLogForm(26);   //      
                break;
    case 0x2:   //   DS1991
    case 0x82:   //   DS1425
                fs=new TFileStream(FilePath,fmOpenRead);        //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)      //  Subkey1
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area1[i]=rffch[0];     //    
                  }
                }
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++) //  Subkey2
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area2[i]=rffch[0];     //    
                  }
                }
                for(unsigned int i=0; i<SelectedChip.Area3Size; i++) //  Subkey3
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area3[i]=rffch[0];     //    
                  }
                }
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //  Subkey1  RichEdit1
                           PlaceDataToForm(3,2);        //  Subkey2  RichEdit3
                           PlaceDataToForm(5,3);        //  Subkey3  RichEdit5
                           break;
                  case 1:  PlaceDataToForm(2,1);        //  Subkey1  RichEdit2
                           PlaceDataToForm(4,2);        //  Subkey2  RichEdit4
                           PlaceDataToForm(6,3);        //  Subkey3  RichEdit6
                           break;
                  default: break;
                }
                break;
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
                fs=new TFileStream(FilePath,fmOpenRead);        //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)      //   
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area1[i]=rffch[0];     //    
                  }
                }
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //    ReachEdit1
                           break;
                  case 1:  PlaceDataToForm(2,1);        //    ReachEdit2
                           break;
                  default: break;
                }
                break;
    case 0x4:   //   DS1994
    case 0x2D:  //   DS2431
    case 0x84:  //   DS1427
                fs=new TFileStream(FilePath,fmOpenRead);        //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)      //   
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area1[i]=rffch[0];     //    
                  }
                }
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++) //   
                { if(fs->Read(rffch,1))                 //    
                  { SelectedChip.Area2[i]=rffch[0];     //    
                  }
                }
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //  
                           PlaceDataToForm(3,2);        //  
                           break;
                  case 1:  PlaceDataToForm(2,1);        //  
                           PlaceDataToForm(4,2);        //  
                           break;
                  default: break;
                }
                break;
    default:    SendMsgToLogForm(17);   //   
                break;
  }
}
//---------------------------------------------------------------------------
//---    HEX-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromHexFileToMemory(AnsiString FilePath)
{ AnsiString TempStr, SubStr;
  unsigned char *InBuf, OutBuf[2];                      //  
  unsigned int n, Reclen, Offset, Rectype, Address,
               LinearBaseAddress, SegmentBaseAddress;

  SendMsgToLogForm(23);         //    HEX-  
  LinearBaseAddress=0;    SegmentBaseAddress=0;         //    
  //    hex-       
  switch(SelectedChip.Family)
  { case 0x0:   //    (    ROM)
                switch(SelectedChip.Modify)
                { case 1:  //    RW1990
                           Form1->Memo1->Clear();                                  //  Memo
                           Form1->Memo1->Lines->LoadFromFile(FilePath);            //    Memo
                           n=Form1->Memo1->Lines->Count;                           //     
                           for(unsigned int i=0;i<n;i++)                           //    
                           {  TempStr=Form1->Memo1->Lines->Strings[i];             //   
                              //       
                              SubStr=TempStr.SubString(2,2);                       // - -     
                              InBuf=SubStr.c_str();
                              HexToBin(InBuf,OutBuf,1);                            //     ()
                              Reclen=OutBuf[0];                                    //      
                              //     
                              SubStr=TempStr.SubString(4,4);                       //     
                              InBuf=SubStr.c_str();
                              HexToBin(InBuf,OutBuf,2);
                              Offset=OutBuf[0]*256+OutBuf[1];
                              //  
                              SubStr=TempStr.SubString(8,2);                       //      
                              InBuf=SubStr.c_str();
                              HexToBin(InBuf,OutBuf,1);
                              Rectype=OutBuf[0];
                              switch(Rectype)
                              { case 0: // Data record
                                        for(unsigned int j=0;j<Reclen;j++)
                                        { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                                          Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                                          InBuf=SubStr.c_str();                                 // SubStr -     hex
                                          HexToBin(InBuf,OutBuf,1);                             //      
                                          if(Address<8)
                                          { SelectedChip.ROM[Address]=OutBuf[0];
                                          }
                                        }
                                        break;
                                case 1: // End of file record
                                        i=n;    //   
                                        Form1->StaticText1->Caption=FilePath;
                                        break;
                                case 2: // Extended segment address record
                                        SubStr=TempStr.SubString(10,4);         // Extended segment address    
                                        InBuf=SubStr.c_str();
                                        HexToBin(InBuf,OutBuf,2);
                                        SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                                        break;
                                case 3: // Start segment address record (  4-19   
                                        //  ,       )
                                        i=n;    //   
                                        SendMsgToLogForm(18);   //  HEX-  8086/80186
                                        break;
                                case 4: // Extended linear address record (  2    
                                        //  ,       )
                                        SubStr=TempStr.SubString(10,4);         // Extended linear address    
                                        InBuf=SubStr.c_str();
                                        HexToBin(InBuf,OutBuf,2);
                                        LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                                        break;
                                case 5: // Start linear address record
                                        i=n;    //   
                                        SendMsgToLogForm(19);   //  HEX-  80386
                                        break;
                                default://        - 
                                        i=n;    //   
                                        SendMsgToLogForm(20);   //   
                                        break;
                              }
                           }
                           Form1->Memo1->Clear();          //  Memo
                           //       ROM  
                           PlaceDataToForm(0,0);           //   ROM  Edit3 (    )
                           break;
                  default: SendMsgToLogForm(17);   //   
                           break;
                }
                break;
    case 0x5:   //   DS2405
    case 0x2C:  //   DS2890
                SendMsgToLogForm(26);   //      
                break;
    case 0x2:   //   DS1991
    case 0x82:  //   DS1425
                Form1->Memo1->Clear();                                  //  Memo
                Form1->Memo1->Lines->LoadFromFile(FilePath);            //    Memo
                n=Form1->Memo1->Lines->Count;                           //     
                for(unsigned int i=0;i<n;i++)                           //    
                {  TempStr=Form1->Memo1->Lines->Strings[i];             //   
                   //       
                   SubStr=TempStr.SubString(2,2);                       // - -     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);                            //     ()
                   Reclen=OutBuf[0];                                    //      
                   //     
                   SubStr=TempStr.SubString(4,4);                       //     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,2);
                   Offset=OutBuf[0]*256+OutBuf[1];
                   //  
                   SubStr=TempStr.SubString(8,2);                       //      
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);
                   Rectype=OutBuf[0];
                   switch(Rectype)
                   { case 0: // Data record
                                for(unsigned int j=0;j<Reclen;j++)
                                { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                                  Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                                  InBuf=SubStr.c_str();                                 // SubStr -     hex
                                  HexToBin(InBuf,OutBuf,1);                             //      
                                  if((Address>=SelectedChip.Area1Start) && (Address<(SelectedChip.Area1Start+SelectedChip.Area1Size)))
                                  { SelectedChip.Area1[Address-SelectedChip.Area1Start]=OutBuf[0];
                                  }
                                  if((Address>=SelectedChip.Area2Start) && (Address<(SelectedChip.Area2Start+SelectedChip.Area2Size)))
                                  { SelectedChip.Area2[Address-SelectedChip.Area2Start]=OutBuf[0];
                                  }
                                  if((Address>=SelectedChip.Area3Start) && (Address<(SelectedChip.Area3Start+SelectedChip.Area3Size)))
                                  { SelectedChip.Area3[Address-SelectedChip.Area3Start]=OutBuf[0];
                                  }
                                }
                                break;
                     case 1: // End of file record
                                i=n;    //   
                                Form1->StaticText1->Caption=FilePath;
                                break;
                     case 2: // Extended segment address record
                                SubStr=TempStr.SubString(10,4);         // Extended segment address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                                break;
                     case 3: // Start segment address record (  4-19   
                             //  ,       )
                                i=n;    //   
                                SendMsgToLogForm(18);   //  HEX-  8086/80186
                                break;
                     case 4: // Extended linear address record (  2    
                             //  ,       )
                                SubStr=TempStr.SubString(10,4);         // Extended linear address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                                break;
                     case 5: // Start linear address record
                                i=n;    //   
                                SendMsgToLogForm(19);   //  HEX-  80386
                                break;
                     default://        - 
                                i=n;    //   
                                SendMsgToLogForm(20);   //   
                                break;
                    }
                }
                Form1->Memo1->Clear();          //  Memo
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //  Subkey1  RichEdit1
                           PlaceDataToForm(3,2);        //  Subkey2  RichEdit3
                           PlaceDataToForm(5,3);        //  Subkey3  RichEdit5
                           break;
                  case 1:  PlaceDataToForm(2,1);        //  Subkey1  RichEdit2
                           PlaceDataToForm(4,2);        //  Subkey2  RichEdit4
                           PlaceDataToForm(6,3);        //  Subkey3  RichEdit6
                           break;
                  default: break;
                }
                break;
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
                Form1->Memo1->Clear();                                  //  Memo
                Form1->Memo1->Lines->LoadFromFile(FilePath);            //    Memo
                n=Form1->Memo1->Lines->Count;                           //     
                for(unsigned int i=0;i<n;i++)                           //    
                {  TempStr=Form1->Memo1->Lines->Strings[i];             //   
                   //       
                   SubStr=TempStr.SubString(2,2);                       // - -     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);                            //     ()
                   Reclen=OutBuf[0];                                    //      
                   //     
                   SubStr=TempStr.SubString(4,4);                       //     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,2);
                   Offset=OutBuf[0]*256+OutBuf[1];
                   //  
                   SubStr=TempStr.SubString(8,2);                       //      
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);
                   Rectype=OutBuf[0];
                   switch(Rectype)
                   { case 0: // Data record
                                for(unsigned int j=0;j<Reclen;j++)
                                { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                                  Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                                  InBuf=SubStr.c_str();                                 // SubStr -     hex
                                  HexToBin(InBuf,OutBuf,1);                             //      
                                  if((Address>=SelectedChip.Area1Start) && (Address<(SelectedChip.Area1Start+SelectedChip.Area1Size)))
                                  { SelectedChip.Area1[Address-SelectedChip.Area1Start]=OutBuf[0];
                                  }
                                }
                                break;
                     case 1: // End of file record
                                i=n;    //   
                                Form1->StaticText1->Caption=FilePath;
                                break;
                     case 2: // Extended segment address record
                                SubStr=TempStr.SubString(10,4);         // Extended segment address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                                break;
                     case 3: // Start segment address record (  4-19   
                             //  ,       )
                                i=n;    //   
                                SendMsgToLogForm(18);   //  HEX-  8086/80186
                                break;
                     case 4: // Extended linear address record (  2    
                             //  ,       )
                                SubStr=TempStr.SubString(10,4);         // Extended linear address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                                break;
                     case 5: // Start linear address record
                                i=n;    //   
                                SendMsgToLogForm(19);   //  HEX-  80386
                                break;
                     default://        - 
                                i=n;    //   
                                SendMsgToLogForm(20);   //   
                                break;
                    }
                }
                Form1->Memo1->Clear();          //  Memo
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //  
                           break;
                  case 1:  PlaceDataToForm(2,1);        //  
                           break;
                  default: break;
                }
                break;
    case 0x4:   //   DS1994
    case 0x2D:  //   DS2431
    case 0x84:  //   DS1427
                Form1->Memo1->Clear();                                  //  Memo
                Form1->Memo1->Lines->LoadFromFile(FilePath);            //    Memo
                n=Form1->Memo1->Lines->Count;                           //     
                for(unsigned int i=0;i<n;i++)                           //    
                {  TempStr=Form1->Memo1->Lines->Strings[i];             //   
                   //       
                   SubStr=TempStr.SubString(2,2);                       // - -     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);                            //     ()
                   Reclen=OutBuf[0];                                    //      
                   //     
                   SubStr=TempStr.SubString(4,4);                       //     
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,2);
                   Offset=OutBuf[0]*256+OutBuf[1];
                   //  
                   SubStr=TempStr.SubString(8,2);                       //      
                   InBuf=SubStr.c_str();
                   HexToBin(InBuf,OutBuf,1);
                   Rectype=OutBuf[0];
                   switch(Rectype)
                   { case 0: // Data record
                                for(unsigned int j=0;j<Reclen;j++)
                                { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                                  Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                                  InBuf=SubStr.c_str();                                 // SubStr -     hex
                                  HexToBin(InBuf,OutBuf,1);                             //      
                                  if((Address>=SelectedChip.Area1Start) && (Address<(SelectedChip.Area1Start+SelectedChip.Area1Size)))
                                  { SelectedChip.Area1[Address-SelectedChip.Area1Start]=OutBuf[0];
                                  }
                                  if((Address>=SelectedChip.Area2Start) && (Address<(SelectedChip.Area2Start+SelectedChip.Area2Size)))
                                  { SelectedChip.Area2[Address-SelectedChip.Area2Start]=OutBuf[0];
                                  }
                                }
                                break;
                     case 1: // End of file record
                                i=n;    //   
                                Form1->StaticText1->Caption=FilePath;
                                break;
                     case 2: // Extended segment address record
                                SubStr=TempStr.SubString(10,4);         // Extended segment address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                                break;
                     case 3: // Start segment address record (  4-19   
                             //  ,       )
                                i=n;    //   
                                SendMsgToLogForm(18);   //  HEX-  8086/80186
                                break;
                     case 4: // Extended linear address record (  2    
                             //  ,       )
                                SubStr=TempStr.SubString(10,4);         // Extended linear address    
                                InBuf=SubStr.c_str();
                                HexToBin(InBuf,OutBuf,2);
                                LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                                break;
                     case 5: // Start linear address record
                                i=n;    //   
                                SendMsgToLogForm(19);   //  HEX-  80386
                                break;
                     default://        - 
                                i=n;    //   
                                SendMsgToLogForm(20);   //   
                                break;
                    }
                }
                Form1->Memo1->Clear();          //  Memo
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  PlaceDataToForm(1,1);        //  
                           PlaceDataToForm(3,2);        //  
                           break;
                  case 1:  PlaceDataToForm(2,1);        //  
                           PlaceDataToForm(4,2);        //  
                           break;
                  default: break;
                }
                break;
    default:    SendMsgToLogForm(17);   //   
                break;
  }
}
//---------------------------------------------------------------------------
//---      BIN- ---------------------------------
//---------------------------------------------------------------------------
void SaveFromMemoryToBinFile(AnsiString FilePath)
{ TFileStream* fs;              //    
  char Symbol[1];               //   

  SendMsgToLogForm(24);         //      BIN-
  //      bin-     
  switch(SelectedChip.Family)
  { case 0x0:   //    (    ROM)
                switch(SelectedChip.Modify)
                { case 1:  //  RW1990
                           //----------------------------------------
                           //       
                           //----------------------------------------
                           GetDataToMemory(0,0);  //  ROM  
                           fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                           for(unsigned int i=0; i<8; i++)
                           { Symbol[0]=char(SelectedChip.ROM[i]);
                             fs->Write(Symbol,1);                                  //  
                           }
                           delete fs;                                              //   
                           Form1->StaticText1->Caption=FilePath;                   //    
                           break;
                  default: SendMsgToLogForm(17);   //   
                           break;
                }
                break;
    case 0x5:   //   DS2405
    case 0x2C:  //   DS2890
                SendMsgToLogForm(26);   //      
                break;
    case 0x2:   //   DS1991
    case 0x82:  //   DS1425
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Subkey1
                           GetDataToMemory(3,2);  //    RichEdit3  Subkey2
                           GetDataToMemory(5,3);  //    RichEdit5  Subkey3
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Subkey1
                           GetDataToMemory(4,2);  //    RichEdit4  Subkey2
                           GetDataToMemory(6,3);  //    RichEdit6  Subkey3
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                { Symbol[0]=char(SelectedChip.Area1[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                { Symbol[0]=char(SelectedChip.Area2[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                for(unsigned int i=0; i<SelectedChip.Area3Size; i++)
                { Symbol[0]=char(SelectedChip.Area3[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                delete fs;                                              //   
                Form1->StaticText1->Caption=FilePath;                   //    
                break;
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Data
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                { Symbol[0]=char(SelectedChip.Area1[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                delete fs;                                              //   
                Form1->StaticText1->Caption=FilePath;                   //    
                break;
    case 0x4:   //   DS1994
    case 0x2D:  //   DS2431
    case 0x84:  //   DS1427
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Data
                           GetDataToMemory(3,2);  //    RichEdit3  Registers
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Data
                           GetDataToMemory(4,2);  //    RichEdit4  Registers
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                { Symbol[0]=char(SelectedChip.Area1[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                { Symbol[0]=char(SelectedChip.Area2[i]);
                  fs->Write(Symbol,1);                                  //  
                }
                delete fs;                                              //   
                Form1->StaticText1->Caption=FilePath;                   //    
                break;
    default:    SendMsgToLogForm(17);   //   
                break;
  }
}
//---------------------------------------------------------------------------
//---      HEX- ---------------------------------
//---------------------------------------------------------------------------
void SaveFromMemoryToHexFile(AnsiString FilePath)
{ TFileStream* fs;                      //    
  unsigned char Value[1], OutBuf[2];    //  
  unsigned char CheckSum[1];            //    

  SendMsgToLogForm(25);         //      hex-
  //      hex-     
  switch(SelectedChip.Family)
  { case 0x0:   //    (    ROM)
                switch(SelectedChip.Modify)
                { case 1:  //  RW1990
                           //----------------------------------------
                           //       
                           //----------------------------------------
                           GetDataToMemory(0,0);  //  ROM  
                           fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                           for(unsigned int i=0; i<8; i++)
                           { if(i%8==0)                            //    ,     i  8  0
                             { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                               fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                               // 
                               Value[0]=i/256;                     //   
                               CheckSum[0]=CheckSum[0]+Value[0];   //      
                               BinToHex(Value,OutBuf,1);           //   ()  
                               fs->Write(OutBuf,2);                //    HEX-   

                               Value[0]=i;                         //   
                               CheckSum[0]=CheckSum[0]+Value[0];   //      
                               BinToHex(Value,OutBuf,1);           //   ()  
                               fs->Write(OutBuf,2);                //    HEX-   

                               OutBuf[0]=0x30;                     //    RECTYPE
                               OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                               fs->Write(OutBuf,2);                //    
                             }
                             //     
                             Value[0]=SelectedChip.ROM[i];
                             BinToHex(Value,OutBuf,1);             //   ()  
                             fs->Write(OutBuf,2);                  //     2 
                             CheckSum[0]=CheckSum[0]+Value[0];     //      
                             //       -    CheckSum +     
                             if((i+1)%8==0)                        //     i+1  8  0
                             { CheckSum[0]=255-CheckSum[0];
                               CheckSum[0]=CheckSum[0]+1;
                               Value[0]=CheckSum[0];
                               BinToHex(Value,OutBuf,1);           //   ()  
                               fs->Write(OutBuf,2);                //   (CheckSum)  
                               Value[0]=0xD;                       //    
                               fs->Write(Value,1);
                               Value[0]=0xA;                       //     
                               fs->Write(Value,1);
                             }
                           }
                           //      
                           fs->Write(":00000001FF",11);            //   
                           delete fs;                              //   
                           Form1->StaticText1->Caption=FilePath;   //    
                           break;
                  default: SendMsgToLogForm(17);   //   
                           break;
                }
                break;
    case 0x5:   //   DS2405
    case 0x2C:  //   DS2890
                SendMsgToLogForm(26);   //      
                break;
    case 0x2:   //   DS1991
    case 0x82:  //   DS1425
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Subkey1
                           GetDataToMemory(3,2);  //    RichEdit3  Subkey2
                           GetDataToMemory(5,3);  //    RichEdit5  Subkey3
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Subkey1
                           GetDataToMemory(4,2);  //    RichEdit4  Subkey2
                           GetDataToMemory(6,2);  //    RichEdit6  Subkey3
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<(SelectedChip.Area1Size+SelectedChip.Area2Size+SelectedChip.Area3Size); i++)
                { if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  //     
                  if(i<SelectedChip.Area1Size)                                  Value[0]=SelectedChip.Area1[i];
                  else if(i<(SelectedChip.Area1Size+SelectedChip.Area2Size))    Value[0]=SelectedChip.Area2[i-SelectedChip.Area1Size];
                  else                                                          Value[0]=SelectedChip.Area3[i-SelectedChip.Area1Size-SelectedChip.Area2Size];
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                break;
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0x10:  //   DS18S20
    case 0x14:  //   DS2430A
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x22:  //   DS1822
    case 0x23:  //   DS24B33
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Data
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Data
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                { if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  //     
                  Value[0]=SelectedChip.Area1[i];
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                break;
    case 0x4:   //   DS1994
    case 0x2D:  //   DS2431
    case 0x84:  //   DS1427
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Data
                           GetDataToMemory(3,2);  //    RichEdit3  Registers
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Data
                           GetDataToMemory(4,2);  //    RichEdit4  Registers
                           break;
                           default: break;
                }
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size+SelectedChip.Area2Size; i++)
                { if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  //     
                  if(i<SelectedChip.Area1Size)   Value[0]=SelectedChip.Area1[i];
                  else                           Value[0]=SelectedChip.Area2[i-SelectedChip.Area1Size];
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                Form1->StaticText1->Caption=FilePath;   //    
                break;
    default:    SendMsgToLogForm(17);   //   
                break;
  }
}
//---------------------------------------------------------------------------

