//---------------------------------------------------------------------------
//      DS1991
//---------------------------------------------------------------------------
#pragma hdrstop
#include "DS1991.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "CalcCRC.h"            //   CRC
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   SCRATCHPAD (0x96) (   4) ----------------------
//---------------------------------------------------------------------------
// output:      Success
DS1991_OUTPUT_DATA DS1991_WriteToScratchpad()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   

  OutputData.Test=0;
  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Write Scratchpad
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x96;                                  // Write Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //  Address
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xC0;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x3F;                                  //    
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //***    ***
  for(unsigned int i=0; i<SelectedChip.Area4Size; i++)          //   ,   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.Area4[i];               //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);        //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area4Size;      //    -
    Sleep(1);
  }
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //  
}
//---------------------------------------------------------------------------
//---   SCRATCHPAD (0x69) (  Area4) --------------------------
//---------------------------------------------------------------------------
// output:      Success
DS1991_OUTPUT_DATA DS1991_ReadFromScratchpad()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   

  OutputData.Test=0;
  OutputData.Success=false;             //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //   Scratchpad-
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x69;                                  // Read Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //  Address
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xC0;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x3F;                                  //    
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //***    ***
  for(unsigned int i=0; i<SelectedChip.Area4Size; i++)  //     (Area4)
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.Area4[i]=rd_buf.Data[0];                               //      
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area4Size;      //    -
    Sleep(1);
  }
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                     LBar->Free();                  //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
//---   SCRATCHPAD  SUBKEY (0x3) -----------------------------
//---------------------------------------------------------------------------
// input:       Input.AreaNumber -    (  1, 2  3)
// output:      Success
DS1991_OUTPUT_DATA DS1991_CopyScratchpadToMemory(DS1991_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   
  unsigned char SA;                     // subkey address
  unsigned char BS[8];                  //   BlockSelector

  BS[0]=0x56;   BS[1]=0x56;     BS[2]=0x7F;     BS[3]=0x51;
  BS[4]=0x57;   BS[5]=0x5D;     BS[6]=0x5A;     BS[7]=0x7F;

  OutputData.Test=0;
  OutputData.Success=false;             //  
  SA=(InputData.AreaNumber-1)<<6;       //   ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Copy Scratchpad
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x3C;                                  // Copy Scratchpad
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   ,    (subkey address)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=SA;                                    //    ,   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    ,    (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=~SA;                                   //   ,   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  block selector code (8 bytes)
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=BS[i];
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();            //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //      (8 bytes)
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i+8];  // Password Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i+8];  // Password Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i+8];  // Password Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  Sleep(10);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;            //  
}
//---------------------------------------------------------------------------
//---  SUBKEY DATA    (1, 2  3) (0x66) -----------
//---------------------------------------------------------------------------
// input:       Input.AreaNumber -    (1, 2  3)
// output:      Success
DS1991_OUTPUT_DATA DS1991_ReadSubKey(DS1991_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   
  unsigned char SA;                     // subkey address
  unsigned char ID[8];                  // readed ID

  OutputData.Test=0;
  OutputData.Success=false;             //  
  SA=(InputData.AreaNumber-1)<<6;       //   ,    
  SA+=0x10;                             //     0x10

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Read SubKey
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x66;                                  // Read SubKey
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   ,      (subkey address + data start)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=SA;                              //     
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    ,      (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=~SA;                             //    
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  
  for(unsigned int i=0; i<8; i++)
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    ID[i]=rd_buf.Data[0];                       //   
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //     
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i+8];  // Password Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i+8];  // Password Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i+8];  // Password Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //       (64-0x10)
  for(unsigned int i=0; i<SelectedChip.Area4Size-0x10; i++)
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    switch(InputData.AreaNumber)
    { case 1:  SelectedChip.Area1[i+0x10]=rd_buf.Data[0];    //      1
               break;
      case 2:  SelectedChip.Area2[i+0x10]=rd_buf.Data[0];    //      2
               break;
      case 3:  SelectedChip.Area3[i+0x10]=rd_buf.Data[0];    //      3
               break;
      default: break;
    }
    LBar->ProgressBar1->Position=100*(i+1)/(SelectedChip.Area4Size-0x10);       //    -
    Sleep(1);
  }
  //         (Test)
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                     LBar->Free();                  //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;            //  
}
//---------------------------------------------------------------------------
//---  SUBKEY DATA    (1, 2  3) (0x99) ------------
//---------------------------------------------------------------------------
// input:       Input.AreaNumber -     (1, 2  3)
// output:      Success
DS1991_OUTPUT_DATA DS1991_WriteSubKey(DS1991_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   
  unsigned char SA;                     // subkey address
  unsigned char ID[8];                  // readed ID

  OutputData.Test=0;
  OutputData.Success=false;             //  
  SA=(InputData.AreaNumber-1)<<6;       //   ,    
  SA+=0x10;                             //     0x10

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Write SubKey
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x99;                                  // Write SubKey
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   ,      (subkey address + data start)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=SA;                              //     
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    ,      (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=~SA;                             //    
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8   (     )
  for(unsigned int i=0; i<8; i++)
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    ID[i]=rd_buf.Data[0];                       //   
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //     
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i+8];  // Password Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i+8];  // Password Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i+8];  // Password Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //       (64-0x10)
  for(unsigned int i=0; i<SelectedChip.Area4Size-0x10; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i+0x10];  // Password Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i+0x10];  // Password Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i+0x10];  // Password Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/(SelectedChip.Area4Size-0x10);       //    -
    Sleep(1);
  }
  Sleep(10);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;            //  
}
//---------------------------------------------------------------------------
//---  ID  PASSWORD    (1, 2  3) (0x5A) ----------
//---------------------------------------------------------------------------
// input:       Input.AreaNumber -     (1, 2  3)
// output:      Success
DS1991_OUTPUT_DATA DS1991_WritePassword(DS1991_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS1991_OUTPUT_DATA OutputData;        //   
  unsigned char SA;                     // subkey address
  unsigned char ID[8];                  // readed ID

  OutputData.Test=0;
  OutputData.Success=false;             //  
  SA=(InputData.AreaNumber-1)<<6;       //   ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Write Password
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x5A;                                  // Write Password
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   ,     ID  Password (subkey address)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=SA;                              //   subkey 
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    ,     ID  Password (one's complement)
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                            // SendByte_1W
  wr_buf.Data[1]=~SA;                             //  subkey 
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);    //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  
  for(unsigned int i=0; i<8; i++)
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    ID[i]=rd_buf.Data[0];                       //   
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //    
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=ID[i];                               // Password Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  Sleep(10);
  //    
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i];    // new ID Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i];    // new ID Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i];    // new ID Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  //    
  for(unsigned int i=0; i<8; i++)
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:  wr_buf.Data[1]=SelectedChip.Area1[i+8];  // new Password Bytes
               break;
      case 2:  wr_buf.Data[1]=SelectedChip.Area2[i+8];  // new Password Bytes
               break;
      case 3:  wr_buf.Data[1]=SelectedChip.Area3[i+8];  // new Password Bytes
               break;
      default: wr_buf.Data[1]=0;
               break;
    }
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    LBar->ProgressBar1->Position=100*(i+1)/8;           //    -
    Sleep(1);
  }
  Sleep(10);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;            //  
}
//---------------------------------------------------------------------------
 