//---------------------------------------------------------------------------
//      DS2405
//---------------------------------------------------------------------------
#pragma hdrstop
#include "DS2405.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---    PIO (  Search ROM 0xF0) ------------
//---------------------------------------------------------------------------
// output:      Test - ,      (0xFF) + Success
DS2405_OUTPUT_DATA DS2405_ReadState()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2405_OUTPUT_DATA OutputData;       //   
  unsigned int CurrentByte, CurrentBit; //     

  OutputData.Test=0x55;
  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Search ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xF0;                                  // Search ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  2 ,   ROM (  64 )
  for(unsigned int i=0; i<64; i++)                       //    ROM
  {   CurrentByte=i/8; CurrentBit=i-8*CurrentByte;
      //    
      wr_buf.Size=1;
      wr_buf.Data[0]=0x64; //   
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);//   
                             LBar->Free();        //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
      // 
      rd_buf=ReadFrom();
      if(!rd_buf.Size){ SendMsgToLogForm(11);//   
                        LBar->Free();        //    -
                        ClosePort();
                        return OutputData;
                      }
      //    
      wr_buf.Size=1;
      wr_buf.Data[0]=0x64; //   
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);//   
                             LBar->Free();        //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
      // 
      rd_buf=ReadFrom();
      if(!rd_buf.Size){ SendMsgToLogForm(11);//   
                        LBar->Free();        //    -
                        ClosePort();
                        return OutputData;
                      }
      //   
      wr_buf.Size=2;
      wr_buf.Data[0]=0x63;
      wr_buf.Data[1]=SelectedChip.ROM[CurrentByte]>>CurrentBit; //    ROM       
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);              //   
                             LBar->Free();                      //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(1);
  }
  //    
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();          //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                              // 
  if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];               //    (  0x0  0xFF)
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------
//---   PIO (Match ROM 0x55) ---------------------------
//---------------------------------------------------------------------------
// output:      Test + Success
DS2405_OUTPUT_DATA DS2405_ToggleState()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS2405_OUTPUT_DATA OutputData;        //   

  OutputData.Test=0x55;
  OutputData.Success=false;             //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //    
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                // ReadByte_1W
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();          //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  rd_buf=ReadFrom();                              // 
  if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                     LBar->Free();                    //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];               //    (  0x0  0xFF)
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
