//---------------------------------------------------------------------------
#pragma hdrstop
#include "FormFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //     
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
form_inf        FormData;       //   
//---------------------------------------------------------------------------
//---    --------------------------------------------
//---------------------------------------------------------------------------
void InitFormInf(unsigned char FamilyCode)
{ //        
  switch(FamilyCode)
  { case 0:     //   
                switch(SelectedChip.Modify)
                { case 1:  //    RW1990
                           FormData.RE1Start=0;                            //  Richedit1    
                           FormData.RE1Size=0;
                           FormData.RE2Start=0;                            //  Richedit2    
                           FormData.RE2Size=0;
                           FormData.RE3Start=0;                            //  Richedit3    
                           FormData.RE3Size=0;
                           FormData.RE4Start=0;                            //  Richedit4    
                           FormData.RE4Size=0;
                           FormData.RE5Start=0;                            //  Richedit5    
                           FormData.RE5Size=0;
                           FormData.RE6Start=0;                            //  Richedit6    
                           FormData.RE6Size=0;
                           FormData.RE7Start=0;                            //  Richedit7    
                           FormData.RE7Size=0;
                           FormData.RE8Start=0;                            //  Richedit8    
                           FormData.RE8Size=0;
                           break;
                  default: break;
                }
                break;
    case 0x2:   //   DS1991
    case 0x82:  //   DS1425
                FormData.RE1Start=SelectedChip.Area1Start;      //  Richedit1     1
                FormData.RE1Size=SelectedChip.Area1Size;
                FormData.RE2Start=SelectedChip.Area1Start;      //  Richedit2     1
                FormData.RE2Size=SelectedChip.Area1Size;
                FormData.RE3Start=SelectedChip.Area2Start;      //  Richedit3     2
                FormData.RE3Size=SelectedChip.Area2Size;
                FormData.RE4Start=SelectedChip.Area2Start;      //  Richedit4     2
                FormData.RE4Size=SelectedChip.Area2Size;
                FormData.RE5Start=SelectedChip.Area3Start;      //  Richedit5     3
                FormData.RE5Size=SelectedChip.Area3Size;
                FormData.RE6Start=SelectedChip.Area3Start;      //  Richedit6     3
                FormData.RE6Size=SelectedChip.Area3Size;
                FormData.RE7Start=SelectedChip.Area4Start;      //  Richedit7    
                FormData.RE7Size=SelectedChip.Area4Size;
                FormData.RE8Start=SelectedChip.Area4Start;      //  Richedit8    
                FormData.RE8Size=SelectedChip.Area4Size;
                break;
    case 0x5:   //   DS2405
    case 0x2C:  //   DS2890
                FormData.RE1Start=0;                            //  Richedit1    
                FormData.RE1Size=0;
                FormData.RE2Start=0;                            //  Richedit2    
                FormData.RE2Size=0;
                FormData.RE3Start=0;                            //  Richedit3    
                FormData.RE3Size=0;
                FormData.RE4Start=0;                            //  Richedit4    
                FormData.RE4Size=0;
                FormData.RE5Start=0;                            //  Richedit5    
                FormData.RE5Size=0;
                FormData.RE6Start=0;                            //  Richedit6    
                FormData.RE6Size=0;
                FormData.RE7Start=0;                            //  Richedit7    
                FormData.RE7Size=0;
                FormData.RE8Start=0;                            //  Richedit8    
                FormData.RE8Size=0;
                break;
    case 0x14:  //   DS2430A
                FormData.RE1Start=SelectedChip.Area1Start;      //  Richedit1    /  
                FormData.RE1Size=SelectedChip.Area1Size;
                FormData.RE2Start=SelectedChip.Area1Start;      //  Richedit2    /  
                FormData.RE2Size=SelectedChip.Area1Size;
                FormData.RE3Start=SelectedChip.Area3Start;      //  Richedit3   Application Register
                FormData.RE3Size=SelectedChip.Area3Size;
                FormData.RE4Start=SelectedChip.Area3Start;      //  Richedit4   Application Register
                FormData.RE4Size=SelectedChip.Area3Size;
                FormData.RE5Start=0;                            //  Richedit5    
                FormData.RE5Size=0;
                FormData.RE6Start=0;                            //  Richedit6    
                FormData.RE6Size=0;
                FormData.RE7Start=0;                            //  Richedit7    
                FormData.RE7Size=0;
                FormData.RE8Start=0;                            //  Richedit8    
                FormData.RE8Size=0;
                break;
    case 0x6:   //   DS1993
    case 0x8:   //   DS1992
    case 0xA:   //   DS1995
    case 0xC:   //   DS1996
    case 0x23:  //   DS24B33
                FormData.RE1Start=SelectedChip.Area1Start;      //  Richedit1   
                FormData.RE1Size=SelectedChip.Area1Size;
                FormData.RE2Start=SelectedChip.Area1Start;      //  Richedit2   
                FormData.RE2Size=SelectedChip.Area1Size;
                FormData.RE3Start=SelectedChip.Area2Start;      //  Richedit3   
                FormData.RE3Size=SelectedChip.Area2Size;
                FormData.RE4Start=SelectedChip.Area2Start;      //  Richedit4   
                FormData.RE4Size=SelectedChip.Area2Size;
                FormData.RE5Start=0;                            //  Richedit5    
                FormData.RE5Size=0;
                FormData.RE6Start=0;                            //  Richedit6    
                FormData.RE6Size=0;
                FormData.RE7Start=0;                            //  Richedit7    
                FormData.RE7Size=0;
                FormData.RE8Start=0;                            //  Richedit8    
                FormData.RE8Size=0;
                break;
    case 0x10:  //   DS18S20
    case 0x22:  //   DS1822
    case 0x24:  //   DS2415
    case 0x27:  //   DS2417
    case 0x28:  //   DS18B20
                FormData.RE1Start=SelectedChip.Area1Start;      //  Richedit1   
                FormData.RE1Size=SelectedChip.Area1Size;
                FormData.RE2Start=SelectedChip.Area1Start;      //  Richedit2   
                FormData.RE2Size=SelectedChip.Area1Size;
                FormData.RE3Start=0;                            //  Richedit3    
                FormData.RE3Size=0;
                FormData.RE4Start=0;                            //  Richedit4    
                FormData.RE4Size=0;
                FormData.RE5Start=0;                            //  Richedit5    
                FormData.RE5Size=0;
                FormData.RE6Start=0;                            //  Richedit6    
                FormData.RE6Size=0;
                FormData.RE7Start=0;                            //  Richedit7    
                FormData.RE7Size=0;
                FormData.RE8Start=0;                            //  Richedit8    
                FormData.RE8Size=0;
                break;
    case 0x4:   //   DS1994
    case 0x1A:  //   DS1963L
    case 0x1D:  //   DS2423
    case 0x2D:  //   DS2431
    case 0x84:  //   DS1427
                FormData.RE1Start=SelectedChip.Area1Start;      //  Richedit1   
                FormData.RE1Size=SelectedChip.Area1Size;
                FormData.RE2Start=SelectedChip.Area1Start;      //  Richedit2   
                FormData.RE2Size=SelectedChip.Area1Size;
                FormData.RE3Start=SelectedChip.Area2Start;      //  Richedit3   
                FormData.RE3Size=SelectedChip.Area2Size;
                FormData.RE4Start=SelectedChip.Area2Start;      //  Richedit4   
                FormData.RE4Size=SelectedChip.Area2Size;
                FormData.RE5Start=SelectedChip.Area3Start;      //  Richedit5   
                FormData.RE5Size=SelectedChip.Area3Size;
                FormData.RE6Start=SelectedChip.Area3Start;      //  Richedit6   
                FormData.RE6Size=SelectedChip.Area3Size;
                FormData.RE7Start=0;                            //  Richedit7    
                FormData.RE7Size=0;
                FormData.RE8Start=0;                            //  Richedit8    
                FormData.RE8Size=0;
                break;
    default:    break;
  }
}
//----------------------------------------------------------------------------------
//---      2, 3,     
//----------------------------------------------------------------------------------
void AllInvisible()
{ Form1->Panel2->Visible        = false;        //    2
  Form1->Panel3->Visible        = false;        //    3
  //   
  Form1->Button4->Visible       = false;
  Form1->Button5->Visible       = false;
  Form1->Button6->Visible       = false;
  Form1->Button7->Visible       = false;
  Form1->Button8->Visible       = false;
  Form1->Button9->Visible       = false;
  Form1->Button10->Visible      = false;
  Form1->Button11->Visible      = false;
  Form1->Button12->Visible      = false;
  //   
  Form1->Label3->Visible        = false;
  Form1->Label4->Visible        = false;
  Form1->Label5->Visible        = false;
  Form1->Label6->Visible        = false;
  //   
  Form1->Edit4->Visible         = false;
  Form1->Edit5->Visible         = false;
  Form1->Edit6->Visible         = false;
  Form1->Edit7->Visible         = false;
  //         
  Form1->PageControl1->Visible  = false;
  Form1->Label7->Visible        = false;
  Form1->RichEdit1->Visible     = false;
  Form1->Label8->Visible        = false;
  Form1->RichEdit2->Visible     = false;
  Form1->Label9->Visible        = false;
  Form1->RichEdit3->Visible     = false;
  Form1->Label10->Visible       = false;
  Form1->RichEdit4->Visible     = false;
  Form1->Label11->Visible       = false;
  Form1->RichEdit5->Visible     = false;
  Form1->Label12->Visible       = false;
  Form1->RichEdit6->Visible     = false;
  Form1->Label13->Visible       = false;
  Form1->RichEdit7->Visible     = false;
  Form1->Label14->Visible       = false;
  Form1->RichEdit8->Visible     = false;
  //  
  Form1->Timer1->Enabled=false;
  //       
  Form1->RichEdit9->Visible=false;      //    
  Form1->RichEdit9->Clear();            //   
  //     
  Form1->CheckBox1->Checked=false;      //   1
  Form1->CheckBox1->Visible=false;      //   
  Form1->CheckBox2->Checked=false;      //   2
  Form1->CheckBox2->Visible=false;      //   
  Form1->CheckBox3->Checked=false;      //   3
  Form1->CheckBox3->Visible=false;      //   
  Form1->CheckBox4->Checked=false;      //   4
  Form1->CheckBox4->Visible=false;      //   
}
//---------------------------------------------------------------------------
//---        ---------------------
//---------------------------------------------------------------------------
void CommonVisible()
{ Form1->Panel2->Visible = true;                //     
  Form1->Panel3->Visible = true;                //  ,    
  Form1->Panel3->Top = Form1->Panel2->Top + Form1->Panel2->Height - 1;  //    
  Form1->Edit1->Text=SelectedChip.Name;         //     
  if(FileExists(SelectedChip.ImageName))        //   
  { Form1->Image1->Picture->LoadFromFile(SelectedChip.ImageName);
  }
  else
  { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
    Form1->Image1->Picture->Bitmap->FreeImage();
  }
  //     
  Form1->RichEdit9->Visible=true;       //    
}
//---------------------------------------------------------------------------
//---      -------------------------------
//---------------------------------------------------------------------------
void EnableControlButtons()
{ Form1->Button4->Enabled       = true;
  Form1->Button5->Enabled       = true;
  Form1->Button6->Enabled       = true;
  Form1->Button7->Enabled       = true;
  Form1->Button8->Enabled       = true;
  Form1->Button9->Enabled       = true;
  Form1->Button10->Enabled      = true;
  Form1->Button11->Enabled      = true;
  Form1->Button12->Enabled      = true;
}
//---------------------------------------------------------------------------
//---      -----------------------------
//---------------------------------------------------------------------------
void DisableControlButtons()
{ Form1->Button4->Enabled       = false;
  Form1->Button5->Enabled       = false;
  Form1->Button6->Enabled       = false;
  Form1->Button7->Enabled       = false;
  Form1->Button8->Enabled       = false;
  Form1->Button9->Enabled       = false;
  Form1->Button10->Enabled      = false;
  Form1->Button11->Enabled      = false;
  Form1->Button12->Enabled      = false;
}
//---------------------------------------------------------------------------
//---       ----------------------
//---------------------------------------------------------------------------
void InitDataOnForm(unsigned char OutForm)
{ unsigned int i;               // 

  switch(OutForm)
  { case 1:     //  RichEdit1 ()
                Form1->RichEdit1->Visible=false;        //   
                Form1->RichEdit1->Clear();              //  RichEdit1
                for(i=0; i<FormData.RE1Size/8; i++)                 //  
                  Form1->RichEdit1->Lines->Add(IntToHex(int(8*i+FormData.RE1Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit1->SelStart=46*(i-1)+44;
                Form1->RichEdit1->SelLength=2;
                Form1->RichEdit1->SelText="";
                Form1->RichEdit1->Visible=true;         //   
                break;
    case 2:     //  RichEdit2 ()
                Form1->RichEdit2->Visible=false;        //   
                Form1->RichEdit2->Clear();              //  RichEdit2
                for(i=0; i<FormData.RE2Size/8; i++)                 //  
                  Form1->RichEdit2->Lines->Add(IntToHex(int(8*i+FormData.RE2Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit2->SelStart=46*(i-1)+44;
                Form1->RichEdit2->SelLength=2;
                Form1->RichEdit2->SelText="";
                Form1->RichEdit2->Visible=true;         //   
                break;
    case 3:     //  RichEdit3 ()
                Form1->RichEdit3->Visible=false;        //   
                Form1->RichEdit3->Clear();              //  RichEdit3
                for(i=0; i<FormData.RE3Size/8; i++)                 //  
                  Form1->RichEdit3->Lines->Add(IntToHex(int(8*i+FormData.RE3Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit3->SelStart=46*(i-1)+44;
                Form1->RichEdit3->SelLength=2;
                Form1->RichEdit3->SelText="";
                Form1->RichEdit3->Visible=true;         //   
                break;
    case 4:     //  RichEdit4 ()
                Form1->RichEdit4->Visible=false;        //   
                Form1->RichEdit4->Clear();              //  RichEdit4
                for(i=0; i<FormData.RE4Size/8; i++)                 //  
                  Form1->RichEdit4->Lines->Add(IntToHex(int(8*i+FormData.RE4Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit4->SelStart=46*(i-1)+44;
                Form1->RichEdit4->SelLength=2;
                Form1->RichEdit4->SelText="";
                Form1->RichEdit4->Visible=true;         //   
                break;
    case 5:     //  RichEdit5 ()
                Form1->RichEdit5->Visible=false;        //   
                Form1->RichEdit5->Clear();              //  RichEdit5
                for(i=0; i<FormData.RE5Size/8; i++)                 //  
                  Form1->RichEdit5->Lines->Add(IntToHex(int(8*i+FormData.RE5Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit5->SelStart=46*(i-1)+44;
                Form1->RichEdit5->SelLength=2;
                Form1->RichEdit5->SelText="";
                Form1->RichEdit5->Visible=true;         //   
    case 6:     //  RichEdit6 ()
                Form1->RichEdit6->Visible=false;        //   
                Form1->RichEdit6->Clear();              //  RichEdit6
                for(i=0; i<FormData.RE6Size/8; i++)                 //  
                  Form1->RichEdit6->Lines->Add(IntToHex(int(8*i+FormData.RE6Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit6->SelStart=46*(i-1)+44;
                Form1->RichEdit6->SelLength=2;
                Form1->RichEdit6->SelText="";
                Form1->RichEdit6->Visible=true;         //   
                break;
    case 7:     //  RichEdit7 ()
                Form1->RichEdit7->Visible=false;        //   
                Form1->RichEdit7->Clear();              //  RichEdit7
                for(i=0; i<FormData.RE7Size/8; i++)                 //  
                  Form1->RichEdit7->Lines->Add(IntToHex(int(8*i+FormData.RE7Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit7->SelStart=46*(i-1)+44;
                Form1->RichEdit7->SelLength=2;
                Form1->RichEdit7->SelText="";
                Form1->RichEdit7->Visible=true;         //   
                break;
    case 8:     //  RichEdit8 ()
                Form1->RichEdit8->Visible=false;        //   
                Form1->RichEdit8->Clear();              //  RichEdit8
                for(i=0; i<FormData.RE8Size/8; i++)                 //  
                  Form1->RichEdit8->Lines->Add(IntToHex(int(8*i+FormData.RE8Start),4)+": FF FF FF FF FF FF FF FF   |   ");
                //     
                Form1->RichEdit8->SelStart=46*(i-1)+44;
                Form1->RichEdit8->SelLength=2;
                Form1->RichEdit8->SelText="";
                Form1->RichEdit8->Visible=true;                 //   
                break;
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---       ------------------------------------
//---------------------------------------------------------------------------
void PlaceDataToForm(unsigned char OutForm, unsigned char InArea)
{ char TempBuf[1], OutHexBuf[3];        //  
  unsigned int LineNum, LocalNum;       //    
  unsigned int Size;                    //   
  AnsiString TempROMStr;                //     ROM

  switch(InArea)   //       
  { case 1:     Size=SelectedChip.Area1Size;
                break;
    case 2:     Size=SelectedChip.Area2Size;
                break;
    case 3:     Size=SelectedChip.Area3Size;
                break;
    case 4:     Size=SelectedChip.Area4Size;
                break;
    default:    Size=0;
                break;
  }

  switch(OutForm)  //    
  { case 0:     //     Edit3
                TempROMStr="";
                for(unsigned int i=0; i<8; i++)
                { //     hex-
                  TempBuf[0]=SelectedChip.ROM[i];       //  
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  TempROMStr+=UpperCase(OutHexBuf);     //    
                  TempROMStr+=" ";
                }
                Form1->Edit3->Text=TempROMStr.SubString(1,23);
                break;
    case 1:     //     RichEdit1
                Form1->RichEdit1->Visible=false;       //   
                for(unsigned int i=0;i<Size;i++)       //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit1->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit1->SelLength=2;                        //  2 
                  Form1->RichEdit1->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit1->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit1->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit1->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit1->SelStart=6;                   //     
                Form1->RichEdit1->SelLength=0;                  //  
                Form1->RichEdit1->Visible=true;                 //   
                break;
    case 2:     //     RichEdit2
                Form1->RichEdit2->Visible=false;       //   
                for(unsigned int i=0;i<Size;i++)       //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //     ()
                  OutHexBuf[2]=0;                       //    
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit2->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit2->SelLength=2;                        //  2 
                  Form1->RichEdit2->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit2->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit2->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit2->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit2->SelStart=6;                   //     
                Form1->RichEdit2->SelLength=0;                  //  
                Form1->RichEdit2->Visible=true;                 //   
                break;
    case 3:     //     RichEdit3
                Form1->RichEdit3->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit3->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit3->SelLength=2;                        //  2 
                  Form1->RichEdit3->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit3->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit3->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit3->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit3->SelStart=6;                   //     
                Form1->RichEdit3->SelLength=0;                  //  
                Form1->RichEdit3->Visible=true;                 //   
                break;
    case 4:     //     RichEdit4
                Form1->RichEdit4->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit4->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit4->SelLength=2;                        //  2 
                  Form1->RichEdit4->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit4->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit4->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit4->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit4->SelStart=6;                   //     
                Form1->RichEdit4->SelLength=0;                  //  
                Form1->RichEdit4->Visible=true;                 //   
                break;
    case 5:     //     RichEdit5
                Form1->RichEdit5->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit5->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit5->SelLength=2;                        //  2 
                  Form1->RichEdit5->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit5->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit5->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit5->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit5->SelStart=6;                   //     
                Form1->RichEdit5->SelLength=0;                  //  
                Form1->RichEdit5->Visible=true;                 //   
                break;
    case 6:     //     RichEdit6
                Form1->RichEdit6->Visible=false;                        //   
                for(unsigned int i=0;i<Size;i++)      //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit6->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit6->SelLength=2;                        //  2 
                  Form1->RichEdit6->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit6->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit6->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit6->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit6->SelStart=6;                   //     
                Form1->RichEdit6->SelLength=0;                  //  
                Form1->RichEdit6->Visible=true;                 //   
                break;
    case 7:     //     RichEdit7
                Form1->RichEdit7->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit7->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit7->SelLength=2;                        //  2 
                  Form1->RichEdit7->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit7->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit7->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit7->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit7->SelStart=6;                   //     
                Form1->RichEdit7->SelLength=0;                  //  
                Form1->RichEdit7->Visible=true;                 //   
                break;
    case 8:     //     RichEdit8
                Form1->RichEdit8->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     hex-
                  switch(InArea)
                  { case 1: TempBuf[0]=SelectedChip.Area1[i];
                            break;
                    case 2: TempBuf[0]=SelectedChip.Area2[i];
                            break;
                    case 3: TempBuf[0]=SelectedChip.Area3[i];
                            break;
                    case 4: TempBuf[0]=SelectedChip.Area4[i];
                            break;
                    default: TempBuf[0]=0;
                             break;
                  }
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //    
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //   
                  Form1->RichEdit8->SelStart=LineNum*46+6+3*LocalNum;   //     
                  Form1->RichEdit8->SelLength=2;                        //  2 
                  Form1->RichEdit8->SelText=UpperCase(OutHexBuf);       //   OutHexBuf (2   -,    )
                  //   
                  Form1->RichEdit8->SelStart=LineNum*46+36+LocalNum;    //     
                  Form1->RichEdit8->SelLength=1;                        //  1 
                  if(unsigned(TempBuf[0])<0x1F) OutHexBuf[1]=0x1F;                //    - 
                  else                          OutHexBuf[1]=TempBuf[0];          //    
                  Form1->RichEdit8->SelText=OutHexBuf[1];               // 
                }
                //    
                Form1->RichEdit8->SelStart=6;                   //     
                Form1->RichEdit8->SelLength=0;                  //  
                Form1->RichEdit8->Visible=true;                 //   
                break;
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---       --------------------------------------
//---------------------------------------------------------------------------
void GetDataToMemory(unsigned char InForm, unsigned char OutArea)
{ AnsiString SubStr;                    //  
  char *InHexBuf, TempBuf[1];           //  
  unsigned int LineNum, LocalNum;       //    
  unsigned int Size;                    //  

  switch(OutArea)  //  ,     
  { case 1:     Size=SelectedChip.Area1Size;
                break;
    case 2:     Size=SelectedChip.Area2Size;
                break;
    case 3:     Size=SelectedChip.Area3Size;
                break;
    case 4:     Size=SelectedChip.Area4Size;
                break;
    default:    Size=0;
                break;
  }

  switch(InForm)//     
  { case 0:     //    Edit3 (ROM)
                Form1->Edit3->Visible=false;            //   
                for(unsigned int i=0;i<8;i++)           //    
                { //        hex
                  Form1->Edit3->SelStart=3*i;           //      (  )
                  Form1->Edit3->SelLength=2;            //  2 
                  SubStr=LowerCase(Form1->Edit3->SelText); //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  SelectedChip.ROM[i]=TempBuf[0];
                }
                //    
                Form1->Edit3->SelStart=0;               //     
                Form1->Edit3->SelLength=0;              //  
                Form1->Edit3->Visible=true;             //   
                break;
    case 1:     //    RichEdit1 ()
                Form1->RichEdit1->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit1->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit1->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit1->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit1->SelStart=6;                   //     
                Form1->RichEdit1->SelLength=0;                  //  
                Form1->RichEdit1->Visible=true;                 //   
                break;
    case 2:     //    RichEdit2 ()
                Form1->RichEdit2->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit2->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit2->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit2->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit2->SelStart=6;                   //     
                Form1->RichEdit2->SelLength=0;                  //  
                Form1->RichEdit2->Visible=true;                 //   
                break;
    case 3:     //    RichEdit3 ()
                Form1->RichEdit3->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit3->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit3->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit3->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit3->SelStart=6;                   //     
                Form1->RichEdit3->SelLength=0;                  //  
                Form1->RichEdit3->Visible=true;                 //   
                break;
    case 4:     //    RichEdit4 ()
                Form1->RichEdit4->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit4->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit4->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit4->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit4->SelStart=6;                   //     
                Form1->RichEdit4->SelLength=0;                  //  
                Form1->RichEdit4->Visible=true;                 //   
                break;
    case 5:     //    RichEdit5 ()
                Form1->RichEdit5->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit5->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit5->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit5->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit5->SelStart=6;                   //     
                Form1->RichEdit5->SelLength=0;                  //  
                Form1->RichEdit5->Visible=true;                 //   
                break;
    case 6:     //    RichEdit6 ()
                Form1->RichEdit6->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit6->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit6->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit6->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit6->SelStart=6;                   //     
                Form1->RichEdit6->SelLength=0;                  //  
                Form1->RichEdit6->Visible=true;                 //   
                break;
    case 7:     //    RichEdit7 ()
                Form1->RichEdit7->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit7->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit7->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit7->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit7->SelStart=6;                   //     
                Form1->RichEdit7->SelLength=0;                  //  
                Form1->RichEdit7->Visible=true;                 //   
                break;
    case 8:     //    RichEdit8 ()
                Form1->RichEdit8->Visible=false;        //   
                for(unsigned int i=0;i<Size;i++)        //    
                { //     
                  LineNum=i/8;                          //  ,    
                  LocalNum=i-8*LineNum;                 //    
                  //        hex
                  Form1->RichEdit8->SelStart=46*LineNum+6+3*LocalNum;   //      (  )
                  Form1->RichEdit8->SelLength=2;                        //  2 
                  SubStr=LowerCase(Form1->RichEdit8->SelText);          //    
                  InHexBuf=SubStr.c_str();               //      (  )
                  HexToBin(InHexBuf,TempBuf,1);          //    ()
                  //   
                  switch(OutArea)
                  { case 1:  SelectedChip.Area1[i]=TempBuf[0];
                             break;
                    case 2:  SelectedChip.Area2[i]=TempBuf[0];
                             break;
                    case 3:  SelectedChip.Area3[i]=TempBuf[0];
                             break;
                    case 4:  SelectedChip.Area4[i]=TempBuf[0];
                             break;
                    default: break;
                  }
                }
                //    
                Form1->RichEdit8->SelStart=6;                   //     
                Form1->RichEdit8->SelLength=0;                  //  
                Form1->RichEdit8->Visible=true;                 //   
                break;
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---       -----------------------
//---------------------------------------------------------------------------
void RenameFormElements()
{ switch(LangNum)
  { case 1:  //   
             Form1->File1->Caption              = "";
             Form1->Open1->Caption              = "   ...";
             Form1->Save1->Caption              = "   ";
             Form1->Saveas1->Caption            = "    ...";
             Form1->SaveLogas1->Caption         = "  ...";
             Form1->Exit1->Caption              = "";
             Form1->ChipSelect1->Caption        = "";
             Form1->LangSelect1->Caption        = "";
             Form1->Lang1->Caption              = "  English";
             Form1->Lang2->Caption              = "! ";
             Form1->Help1->Caption              = "";
             Form1->About1->Caption             = " ";
             Form1->Button1->Caption            = "";
             Form1->Button2->Caption            = "";
             Form1->Button3->Caption            = "  1-Wire";
             Form1->Label1->Caption             = ":";
             Form1->Label2->Caption             = " ROM:";
             Form1->WritableKeys1->Caption      = " ";
             Form1->Button13->Caption           = " CRC";
             break;
    case 0:  //   
    default: // - - 
             Form1->File1->Caption              = "File";
             Form1->Open1->Caption              = "Load Data from File...";
             Form1->Save1->Caption              = "Save Data to File";
             Form1->Saveas1->Caption            = "Save Data to File as...";
             Form1->SaveLogas1->Caption         = "Save Log as...";
             Form1->Exit1->Caption              = "Exit";
             Form1->ChipSelect1->Caption        = "ChipSelect";
             Form1->LangSelect1->Caption        = "LangSelect";
             Form1->Lang1->Caption              = "! English";
             Form1->Lang2->Caption              = "  ";
             Form1->Help1->Caption              = "Help";
             Form1->About1->Caption             = "About";
             Form1->Button1->Caption            = "Connect";
             Form1->Button2->Caption            = "Disconnect";
             Form1->Button3->Caption            = "Scan 1-Wire Bus";
             Form1->Label1->Caption             = "Founded:";
             Form1->Label2->Caption             = "Selected ROM:";
             Form1->WritableKeys1->Caption      = "Writable Keys";
             Form1->Button13->Caption           = "Calculate CRC";
             break;
  }
}
//---------------------------------------------------------------------------
//---    ------------------------------------------------
//---------------------------------------------------------------------------
void SaveLangOptions()
{ TFileStream* fs;              //    
  char Symbol[1];               //   

  fs = new TFileStream("options.ini",fmCreate|fmOpenWrite);  //    
  Symbol[0]=char(LangNum);                                   // ,   
  fs->Write(Symbol,1);                                       //   
  delete fs;                                                 //   
}
//---------------------------------------------------------------------------
//---  ͨ   -------------------------------------
//---------------------------------------------------------------------------
void LoadLangOptions()
{ TFileStream* fs;              //    
  unsigned char rffch[1];       //     

  if(FileExists("options.ini"))
  { fs=new TFileStream("options.ini",fmOpenRead);         //    
    if(fs->Read(rffch,1))         LangNum=rffch[0];       //        
    else                          LangNum=0;              // - - 
    delete fs;                                            //   
  }
  else                          LangNum=0;              // - - 
}
//---------------------------------------------------------------------------
//---       ---------------------
//---------------------------------------------------------------------------
void InitForm(unsigned char FamilyCode)
{ AllInvisible();                                               //   
  if(Port!=INVALID_HANDLE_VALUE)  EnableControlButtons();       //   
  else                            DisableControlButtons();
  //        
  switch(FamilyCode)
  { case 0x0: //    (    ROM)
                switch(SelectedChip.Modify)     //    
                { case 1: //     RW1990
                          //  
                           Form1->Button4->Caption = "Write ROM";       //   
                           Form1->Button4->Height  = 21;                //  
                           Form1->Button4->Width   = 80;                //  
                           Form1->Button4->Left    = 8;                 //    
                           Form1->Button4->Top     = 8;                 //    
                           Form1->Button4->Visible = true;              //   
                           Form1->Button5->Caption = "Read ROM";        //   
                           Form1->Button5->Height  = 21;                //  
                           Form1->Button5->Width   = 80;                //  
                           Form1->Button5->Left    = 87;                //    
                           Form1->Button5->Top     = 8;                 //    
                           Form1->Button5->Visible = true;              //   
                          //  Panel2
                           Form1->Panel2->Height           = 153;       //  
                          //  PageControl1
                           //  ,    
                          //        PageControl1
                           Form1->Label15->Top             = 33;        //       
                           Form1->RichEdit9->Top           = 49;        //       
                          //        
                           SendMsgToLogForm(152);  //   
                           break;
                  default: break;
                }
                break;
    case 0x2: //     DS1991
    case 0x82://     DS1425
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 123;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to Subkey";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Data to Subkey";       //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Read Data from Subkey";      //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 123;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Write Password to Subkey";   //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 150;                          //  
                Form1->Button9->Left    = 239;                          //    
                Form1->Button9->Top     = 28;                           //    
                Form1->Button9->Visible = true;                         //   
              //  
                Form1->CheckBox1->Left  = 8;                            //    
                Form1->CheckBox1->Top   = 54;                           //   
                Form1->CheckBox1->Width = 169;                          // 
                Form1->CheckBox1->Caption = "Apply Action for Subkey 1";
                Form1->CheckBox1->Visible = true;                       //  
                Form1->CheckBox2->Left  = 200;                          //    
                Form1->CheckBox2->Top   = 54;                           //   
                Form1->CheckBox2->Width = 169;                          // 
                Form1->CheckBox2->Caption = "Apply Action for Subkey 2";
                Form1->CheckBox2->Visible = true;                       //  
                Form1->CheckBox3->Left  = 8;                            //    
                Form1->CheckBox3->Top   = 78;                           //   
                Form1->CheckBox3->Width = 169;                          // 
                Form1->CheckBox3->Caption = "Apply Action for Subkey 3";
                Form1->CheckBox3->Visible = true;                       //  
              //  Panel2
                Form1->Panel2->Height           = 614;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 394;                  //     
                Form1->PageControl1->Top        = 98;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Subkey 1:";          //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 70;                   //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                      //  RichEdit1
                Form1->Label8->Caption          = "Subkey 1:";          //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 70;                   //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Subkey 2:";          //   
                Form1->Label9->Top              = 93;                   //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 70;                   //  RichEdit3
                Form1->RichEdit3->Top           = 109;                  //    
              InitDataOnForm(3);                                      //  RichEdit13
                Form1->Label10->Caption         = "Subkey 2:";          //   
                Form1->Label10->Top             = 93;                   //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 70;                   //  RichEdit4
                Form1->RichEdit4->Top           = 109;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label11->Caption         = "Subkey 3:";          //   
                Form1->Label11->Top             = 186;                  //    
                Form1->Label11->Visible         = true;                 //   
                Form1->RichEdit5->Height        = 70;                   //  RichEdit5
                Form1->RichEdit5->Top           = 202;                  //    
              InitDataOnForm(5);                                      //  RichEdit15
                Form1->Label12->Caption         = "Subkey 3:";          //   
                Form1->Label12->Top             = 186;                  //    
                Form1->Label12->Visible         = true;                 //   
                Form1->RichEdit6->Height        = 70;                   //  RichEdit6
                Form1->RichEdit6->Top           = 202;                  //    
              InitDataOnForm(6);                                        //  RichEdit6
                Form1->Label13->Caption         = "Scratchpad:";        //   
                Form1->Label13->Top             = 279;                  //    
                Form1->Label13->Visible         = true;                 //   
                Form1->RichEdit7->Height        = 70;                   //  RichEdit7
                Form1->RichEdit7->Top           = 295;                  //    
              InitDataOnForm(7);                                      //  RichEdit17
                Form1->Label14->Caption         = "Scratchpad:";        //   
                Form1->Label14->Top             = 279;                  //    
                Form1->Label14->Visible         = true;                 //   
                Form1->RichEdit8->Height        = 70;                   //  RichEdit8
                Form1->RichEdit8->Top           = 295;                  //    
              InitDataOnForm(8);                                        //  RichEdit8
                Form1->Label15->Top             = 494;                  //       
                Form1->RichEdit9->Top           = 510;                  //       
                //        
                SendMsgToLogForm(132);  //   
                break;
    case 0x4: //     DS1994
    case 0x84://     DS1427
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 100;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 126;                          //  
                Form1->Button5->Left    = 107;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to Memory";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 242;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Data Memory";          //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 100;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Write Timekeeping Regs";     //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 126;                          //  
                Form1->Button8->Left    = 107;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Data Memory";           //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 100;                          //  
                Form1->Button9->Left    = 8;                            //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
                Form1->Button10->Caption = "Read Timekeeping Regs";     //   
                Form1->Button10->Height  = 21;                          //  
                Form1->Button10->Width   = 126;                         //  
                Form1->Button10->Left    = 107;                         //    
                Form1->Button10->Top     = 48;                          //    
                Form1->Button10->Visible = true;                        //   
              //  
                Form1->Label3->Caption   = "TA1";                       //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 20;                          //  
                Form1->Label3->Left      = 250;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
                Form1->Label4->Caption   = "TA2";                       //   
                Form1->Label4->Height    = 13;                          //  
                Form1->Label4->Width     = 20;                          //  
                Form1->Label4->Left      = 287;                         //    
                Form1->Label4->Top       = 32;                          //    
                Form1->Label4->Visible   = true;                        //   
                Form1->Label5->Caption   = "E/S";                       //   
                Form1->Label5->Height    = 13;                          //  
                Form1->Label5->Width     = 20;                          //  
                Form1->Label5->Left      = 325;                         //    
                Form1->Label5->Top       = 32;                          //    
                Form1->Label5->Visible   = true;                        //   
                Form1->Label6->Caption   = "Test";                      //   
                Form1->Label6->Height    = 13;                          //  
                Form1->Label6->Width     = 24;                          //  
                Form1->Label6->Left      = 361;                         //    
                Form1->Label6->Top       = 32;                          //    
                Form1->Label6->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "00";                        //   
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 21;                          //  
                Form1->Edit4->Left       = 250;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
                Form1->Edit5->Text       = "00";                        //   
                Form1->Edit5->Height     = 21;                          //  
                Form1->Edit5->Width      = 21;                          //  
                Form1->Edit5->Left       = 287;                         //    
                Form1->Edit5->Top        = 48;                          //    
                Form1->Edit5->Visible    = true;                        //   
                Form1->Edit6->Text       = "00";                        //   
                Form1->Edit6->Height     = 21;                          //  
                Form1->Edit6->Width      = 21;                          //  
                Form1->Edit6->Left       = 325;                         //    
                Form1->Edit6->Top        = 48;                          //    
                Form1->Edit6->Visible    = true;                        //   
                Form1->Edit7->Text       = "00";                        //   
                Form1->Edit7->Height     = 21;                          //  
                Form1->Edit7->Width      = 21;                          //  
                Form1->Edit7->Left       = 361;                         //    
                Form1->Edit7->Top        = 48;                          //    
                Form1->Edit7->Visible    = true;                        //   
              //  
                Form1->CheckBox1->Left  = 8;                            //    
                Form1->CheckBox1->Top   = 74;                           //   
                Form1->CheckBox1->Width = 169;                          // 
                Form1->CheckBox1->Caption = "Read/Write Status byte";
                Form1->CheckBox1->Visible = true;                       //  
                Form1->CheckBox2->Left  = 8;                            //    
                Form1->CheckBox2->Top   = 98;                           //   
                Form1->CheckBox2->Width = 169;                          // 
                Form1->CheckBox2->Caption = "Read/Write Control byte";
                Form1->CheckBox2->Visible = true;
                Form1->CheckBox3->Left  = 170;                          //    
                Form1->CheckBox3->Top   = 74;                           //   
                Form1->CheckBox3->Width = 350;                          // 
                Form1->CheckBox3->Caption = "Read/Write all others timekeeping bytes";
                Form1->CheckBox3->Visible = true;                       //  
                Form1->CheckBox4->Left  = 170;                          //    
                Form1->CheckBox4->Top   = 98;                           //   
                Form1->CheckBox4->Width = 350;                          // 
                Form1->CheckBox4->Caption = "Apply Copy Scratchpad Three Times";
                Form1->CheckBox4->Visible = true;                       //  
              //  Panel2
                Form1->Panel2->Height           = 632;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 392;                  //     
                Form1->PageControl1->Top        = 118;                  //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Data Memory:";       //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 161;                  //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                        //  RichEdit1
                Form1->Label8->Caption          = "Data Memory:";       //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 161;                  //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Timekeeping registers:";     //   
                Form1->Label9->Top              = 184;                  //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 70;                   //  RichEdit3
                Form1->RichEdit3->Top           = 200;                  //    
              InitDataOnForm(3);                                        //  RichEdit3
                Form1->Label10->Caption         = "Timekeeping registers:";     //   
                Form1->Label10->Top             = 184;                  //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 70;                   //  RichEdit4
                Form1->RichEdit4->Top           = 200;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label11->Caption         = "Scratchpad:";        //   
                Form1->Label11->Top             = 277;                  //    
                Form1->Label11->Visible         = true;                 //   
                Form1->RichEdit5->Height        = 70;                   //  RichEdit5
                Form1->RichEdit5->Top           = 293;                  //    
              InitDataOnForm(5);                                        //  RichEdit5
                Form1->Label12->Caption         = "Scratchpad:";        //   
                Form1->Label12->Top             = 277;                  //    
                Form1->Label12->Visible         = true;                 //   
                Form1->RichEdit6->Height        = 70;                   //  RichEdit6
                Form1->RichEdit6->Top           = 293;                  //    
              InitDataOnForm(6);                                        //  RichEdit6
                Form1->Label15->Top             = 512;                  //       
                Form1->RichEdit9->Top           = 528;                  //       
                break;
    case 0x5: //     DS2405
              //  
                Form1->Button4->Caption = "Read State";                 //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 80;                           //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Toggle State";               //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 80;                           //  
                Form1->Button5->Left    = 87;                           //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
              //  
                Form1->Label3->Caption   = "Readed State:";             //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 84;                          //  
                Form1->Label3->Left      = 185;                         //    
                Form1->Label3->Top       = 12;                          //    
                Form1->Label3->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "???";                       //    Current State
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 84;                          //  
                Form1->Edit4->Left       = 257;                         //    
                Form1->Edit4->Top        = 8;                           //    
                Form1->Edit4->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 153;                  //  
              //  PageControl1
                //  ,    
              //        PageControl1
                Form1->Label15->Top             = 33;                   //       
                Form1->RichEdit9->Top           = 49;                   //       
                break;
    case 0x10://     DS18S20
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 110;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to EEPROM";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Start Cyclic Polling";       //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Stop Cyclic Polling";        //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 110;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Power Supply";          //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 110;                          //  
                Form1->Button9->Left    = 8;                            //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
                Form1->Button10->Caption = "Read EEPROM";               //   
                Form1->Button10->Height  = 21;                          //  
                Form1->Button10->Width   = 110;                         //  
                Form1->Button10->Left    = 117;                         //    
                Form1->Button10->Top     = 48;                          //    
                Form1->Button10->Visible = true;                        //   
              //  
                Form1->Label3->Caption   = "Temperature (oC)";          //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 84;                          //  
                Form1->Label3->Left      = 247;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "???";                       //    Temp(oC)
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 84;                          //  
                Form1->Edit4->Left       = 247;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 265;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 70;                   //     
                Form1->PageControl1->Top        = 73;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Scratchpad:";        //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 25;                   //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                      //  RichEdit1
                Form1->Label8->Caption          = "Scratchpad:";        //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 25;                   //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label15->Top             = 145;                  //       
                Form1->RichEdit9->Top           = 161;                  //       
                //        
                SendMsgToLogForm(130);  //     write scratchpad
                break;
    case 0x14://     DS2430A
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 114;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 115;                          //  
                Form1->Button5->Left    = 121;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to EEPROM";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 151;                          //  
                Form1->Button6->Left    = 242;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Application Register";               //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 140;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Write EEPROM";               //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 89;                           //  
                Form1->Button8->Left    = 147;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Status Register";       //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 151;                          //  
                Form1->Button9->Left    = 242;                          //    
                Form1->Button9->Top     = 28;                           //    
                Form1->Button9->Visible = true;                         //   
                Form1->Button10->Caption = "Read Application Register";  //   
                Form1->Button10->Height  = 21;                           //  
                Form1->Button10->Width   = 140;                          //  
                Form1->Button10->Left    = 8;                            //    
                Form1->Button10->Top     = 48;                           //    
                Form1->Button10->Visible = true;                         //   
                Form1->Button11->Caption = "Read EEPROM";               //   
                Form1->Button11->Height  = 21;                          //  
                Form1->Button11->Width   = 89;                          //  
                Form1->Button11->Left    = 147;                         //    
                Form1->Button11->Top     = 48;                          //    
                Form1->Button11->Visible = true;                        //   
                Form1->Button12->Caption = "Copy Application Register && Lock";//   
                Form1->Button12->Height  = 21;                          //  
                Form1->Button12->Width   = 228;                         //  
                Form1->Button12->Left    = 8;                           //    
                Form1->Button12->Top     = 68;                          //    
                Form1->Button12->Visible = true;                        //   
              //  
                Form1->Label3->Caption   = "Status Register:";          //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 75;                          //  
                Form1->Label3->Left      = 260;                         //    
                Form1->Label3->Top       = 62;                          //    
                Form1->Label3->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "00";                        //   
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 21;                          //  
                Form1->Edit4->Left       = 339;                         //    
                Form1->Edit4->Top        = 58;                          //    
                Form1->Edit4->Visible    = true;                        //   
                //  Panel2
                Form1->Panel2->Height           = 379;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 163;                  //     
                Form1->PageControl1->Top        = 94;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Scratchpad / EEPROM Memory:"; //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 70;                   //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                        //  RichEdit1
                Form1->Label8->Caption          = "Scratchpad / EEPROM Memory:"; //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 70;                   //  RichEdit1
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Application Register:"; //   
                Form1->Label9->Top              = 93;                   //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 25;                   //  RichEdit3
                Form1->RichEdit3->Top           = 109;                  //    
              InitDataOnForm(3);                                        //  RichEdit3
                Form1->Label10->Caption         = "Application Register:"; //   
                Form1->Label10->Top             = 93;                   //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 25;                   //  RichEdit4
                Form1->RichEdit4->Top           = 109;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label15->Top             = 259;                  //       
                Form1->RichEdit9->Top           = 275;                  //       
                break;
    case 0x1A://     DS1963L
    case 0x1D://     DS2423
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 110;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to Memory";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Data Memory";          //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Read Data Memory";           //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 110;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Data Memory and Counters"; //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 219;                          //  
                Form1->Button9->Left    = 8;                            //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
              //  
                Form1->Label3->Caption   = "TA1";                       //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 20;                          //  
                Form1->Label3->Left      = 247;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
                Form1->Label4->Caption   = "TA2";                       //   
                Form1->Label4->Height    = 13;                          //  
                Form1->Label4->Width     = 20;                          //  
                Form1->Label4->Left      = 284;                         //    
                Form1->Label4->Top       = 32;                          //    
                Form1->Label4->Visible   = true;                        //   
                Form1->Label5->Caption   = "E/S";                       //   
                Form1->Label5->Height    = 13;                          //  
                Form1->Label5->Width     = 20;                          //  
                Form1->Label5->Left      = 322;                         //    
                Form1->Label5->Top       = 32;                          //    
                Form1->Label5->Visible   = true;                        //   
                Form1->Label6->Caption   = "Test";                      //   
                Form1->Label6->Height    = 13;                          //  
                Form1->Label6->Width     = 20;                          //  
                Form1->Label6->Left      = 358;                         //    
                Form1->Label6->Top       = 32;                          //    
                Form1->Label6->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "00";                        //   
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 21;                          //  
                Form1->Edit4->Left       = 247;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
                Form1->Edit5->Text       = "00";                        //   
                Form1->Edit5->Height     = 21;                          //  
                Form1->Edit5->Width      = 21;                          //  
                Form1->Edit5->Left       = 284;                         //    
                Form1->Edit5->Top        = 48;                          //    
                Form1->Edit5->Visible    = true;                        //   
                Form1->Edit6->Text       = "00";                        //   
                Form1->Edit6->Height     = 21;                          //  
                Form1->Edit6->Width      = 21;                          //  
                Form1->Edit6->Left       = 322;                         //    
                Form1->Edit6->Top        = 48;                          //    
                Form1->Edit6->Visible    = true;                        //   
                Form1->Edit7->Text       = "00";                        //   
                Form1->Edit7->Height     = 21;                          //  
                Form1->Edit7->Width      = 21;                          //  
                Form1->Edit7->Left       = 359;                         //    
                Form1->Edit7->Top        = 48;                          //    
                Form1->Edit7->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 555;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 360;                  //     
                Form1->PageControl1->Top        = 73;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "EEPROM Data Memory:";//   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 161;                  //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                        //  RichEdit1
                Form1->Label8->Caption          = "EEPROM Data Memory:";//   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 161;                  //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Scratchpad:";        //   
                Form1->Label9->Top              = 184;                  //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 70;                   //  RichEdit3
                Form1->RichEdit3->Top           = 200;                  //    
              InitDataOnForm(3);                                        //  RichEdit3
                Form1->Label10->Caption         = "Scratchpad:";        //   
                Form1->Label10->Top             = 184;                  //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 70;                   //  RichEdit4
                Form1->RichEdit4->Top           = 200;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label11->Caption         = "Counters:";          //   
                Form1->Label11->Top             = 277;                  //    
                Form1->Label11->Visible         = true;                 //   
                Form1->RichEdit5->Height        = 38;                   //  RichEdit5
                Form1->RichEdit5->Top           = 293;                  //    
              InitDataOnForm(5);                                        //  RichEdit5
                Form1->Label12->Caption         = "Counters:";          //   
                Form1->Label12->Top             = 277;                  //    
                Form1->Label12->Visible         = true;                 //   
                Form1->RichEdit6->Height        = 38;                   //  RichEdit6
                Form1->RichEdit6->Top           = 293;                  //    
              InitDataOnForm(6);                                        //  RichEdit6
                Form1->Label15->Top             = 435;                  //       
                Form1->RichEdit9->Top           = 451;                  //       
                //        
                SendMsgToLogForm(147);  //    Counter
                break;
    case 0x6: //     DS1993
    case 0x8: //     DS1992
    case 0xA: //     DS1995
    case 0xC: //     DS1996
    case 0x23://     DS24B33
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 110;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to Memory";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Data Memory";          //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Read Data Memory";           //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 110;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
              //  
                Form1->Label3->Caption   = "TA1";                       //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 20;                          //  
                Form1->Label3->Left      = 247;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
                Form1->Label4->Caption   = "TA2";                       //   
                Form1->Label4->Height    = 13;                          //  
                Form1->Label4->Width     = 20;                          //  
                Form1->Label4->Left      = 284;                         //    
                Form1->Label4->Top       = 32;                          //    
                Form1->Label4->Visible   = true;                        //   
                Form1->Label5->Caption   = "E/S";                       //   
                Form1->Label5->Height    = 13;                          //  
                Form1->Label5->Width     = 20;                          //  
                Form1->Label5->Left      = 322;                         //    
                Form1->Label5->Top       = 32;                          //    
                Form1->Label5->Visible   = true;                        //   
                Form1->Label6->Caption   = "Test";                      //   
                Form1->Label6->Height    = 13;                          //  
                Form1->Label6->Width     = 20;                          //  
                Form1->Label6->Left      = 358;                         //    
                Form1->Label6->Top       = 32;                          //    
                Form1->Label6->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "00";                        //    TA1
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 21;                          //  
                Form1->Edit4->Left       = 247;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
                Form1->Edit5->Text       = "00";                        //    TA2
                Form1->Edit5->Height     = 21;                          //  
                Form1->Edit5->Width      = 21;                          //  
                Form1->Edit5->Left       = 284;                         //    
                Form1->Edit5->Top        = 48;                          //    
                Form1->Edit5->Visible    = true;                        //   
                Form1->Edit6->Text       = "00";                        //    E/S
                Form1->Edit6->Height     = 21;                          //  
                Form1->Edit6->Width      = 21;                          //  
                Form1->Edit6->Left       = 322;                         //    
                Form1->Edit6->Top        = 48;                          //    
                Form1->Edit6->Visible    = true;                        //   
                Form1->Edit7->Text       = "00";                        //    Test
                Form1->Edit7->Height     = 21;                          //  
                Form1->Edit7->Width      = 21;                          //  
                Form1->Edit7->Left       = 359;                         //    
                Form1->Edit7->Top        = 48;                          //    
                Form1->Edit7->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 494;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 299;                  //     
                Form1->PageControl1->Top        = 73;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "EEPROM Data Memory:";//   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 161;                  //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                        //  RichEdit1
                Form1->Label8->Caption          = "EEPROM Data Memory:";//   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 161;                  //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Scratchpad:";        //   
                Form1->Label9->Top              = 184;                  //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 70;                   //  RichEdit3
                Form1->RichEdit3->Top           = 200;                  //    
              InitDataOnForm(3);                                        //  RichEdit3
                Form1->Label10->Caption         = "Scratchpad:";        //   
                Form1->Label10->Top             = 184;                  //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 70;                   //  RichEdit4
                Form1->RichEdit4->Top           = 200;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label15->Top             = 374;                  //       
                Form1->RichEdit9->Top           = 390;                  //       
                break;
    case 0x24: //     DS2415
    case 0x27: //     DS2417
              //  
                Form1->Button4->Caption = "Write Clock (Control + Counter)";    //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 193;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Clock (Control + Counter)";     //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 193;                          //  
                Form1->Button5->Left    = 200;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
              //  Panel2
                Form1->Panel2->Height           = 225;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 70;                   //     
                Form1->PageControl1->Top        = 33;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Control + Counter bytes:";   //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 25;                   //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                      //  RichEdit1
                Form1->Label8->Caption          = "Control + Counter bytes:";   //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 25;                   //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label15->Top             = 105;                  //       
                Form1->RichEdit9->Top           = 121;                  //       
                //        
                SendMsgToLogForm(141);  //    
                break;
    case 0x22://     DS1822
    case 0x28://     DS18B20
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 110;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to EEPROM";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Start Cyclic Polling";       //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Stop Cyclic Polling";        //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 110;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Power Supply";          //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 110;                          //  
                Form1->Button9->Left    = 8;                            //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
                Form1->Button10->Caption = "Read EEPROM";               //   
                Form1->Button10->Height  = 21;                          //  
                Form1->Button10->Width   = 110;                         //  
                Form1->Button10->Left    = 117;                         //    
                Form1->Button10->Top     = 48;                          //    
                Form1->Button10->Visible = true;                        //   
              //  
                Form1->Label3->Caption   = "Temperature (oC)";          //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 84;                          //  
                Form1->Label3->Left      = 247;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "???";                       //    Temp(oC)
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 84;                          //  
                Form1->Edit4->Left       = 247;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 265;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 70;                  //     
                Form1->PageControl1->Top        = 73;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "Scratchpad:";        //   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 25;                   //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                      //  RichEdit1
                Form1->Label8->Caption          = "Scratchpad:";        //   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 25;                   //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label15->Top             = 145;                  //       
                Form1->RichEdit9->Top           = 161;                  //       
                //        
                SendMsgToLogForm(131);  //     write scratchpad
                break;
    case 0x2C://     DS2890
              //  
                Form1->Button4->Caption = "Write Position";             //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 80;                           //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Position";              //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 80;                           //  
                Form1->Button5->Left    = 87;                           //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Increment";                  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 80;                           //  
                Form1->Button6->Left    = 8;                            //    
                Form1->Button6->Top     = 28;                           //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Decrement";                  //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 80;                           //  
                Form1->Button7->Left    = 87;                           //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Write Control";              //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 80;                           //  
                Form1->Button8->Left    = 8;                            //    
                Form1->Button8->Top     = 48;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Read Control";               //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 80;                           //  
                Form1->Button9->Left    = 87;                           //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
              //  
                Form1->Label3->Caption   = "Position Value:";           //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 84;                          //  
                Form1->Label3->Left      = 185;                         //    
                Form1->Label3->Top       = 12;                          //    
                Form1->Label3->Visible   = true;                        //   
                Form1->Label4->Caption   = "Control Register:";         //   
                Form1->Label4->Height    = 13;                          //  
                Form1->Label4->Width     = 84;                          //  
                Form1->Label4->Left      = 185;                         //    
                Form1->Label4->Top       = 32;                          //    
                Form1->Label4->Visible   = true;                        //   
                Form1->Label5->Caption   = "Feature Register:";         //   
                Form1->Label5->Height    = 13;                          //  
                Form1->Label5->Width     = 84;                          //  
                Form1->Label5->Left      = 185;                         //    
                Form1->Label5->Top       = 52;                          //    
                Form1->Label5->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "???";                       //    Position Value
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 44;                          //  
                Form1->Edit4->Left       = 270;                         //    
                Form1->Edit4->Top        = 8;                           //    
                Form1->Edit4->Visible    = true;                        //   
                Form1->Edit5->Text       = "???";                       //    Control Register
                Form1->Edit5->Height     = 21;                          //  
                Form1->Edit5->Width      = 44;                          //  
                Form1->Edit5->Left       = 270;                         //    
                Form1->Edit5->Top        = 28;                          //    
                Form1->Edit5->Visible    = true;                        //   
                Form1->Edit6->Text       = "???";                       //    Feature Register
                Form1->Edit6->Height     = 21;                          //  
                Form1->Edit6->Width      = 44;                          //  
                Form1->Edit6->Left       = 270;                         //    
                Form1->Edit6->Top        = 48;                          //    
                Form1->Edit6->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 193;                  //  
              //  PageControl1
                //    
              //        PageControl1
                Form1->Label15->Top             = 73;                    //       
                Form1->RichEdit9->Top           = 89;                    //       
                break;
    case 0x2D://     DS2431
              //  
                Form1->Button4->Caption = "Write Scratchpad";           //   
                Form1->Button4->Height  = 21;                           //  
                Form1->Button4->Width   = 110;                          //  
                Form1->Button4->Left    = 8;                            //    
                Form1->Button4->Top     = 8;                            //    
                Form1->Button4->Visible = true;                         //   
                Form1->Button5->Caption = "Read Scratchpad";            //   
                Form1->Button5->Height  = 21;                           //  
                Form1->Button5->Width   = 110;                          //  
                Form1->Button5->Left    = 117;                          //    
                Form1->Button5->Top     = 8;                            //    
                Form1->Button5->Visible = true;                         //   
                Form1->Button6->Caption = "Copy Scratchpad to Memory";  //   
                Form1->Button6->Height  = 21;                           //  
                Form1->Button6->Width   = 150;                          //  
                Form1->Button6->Left    = 239;                          //    
                Form1->Button6->Top     = 8;                            //    
                Form1->Button6->Visible = true;                         //   
                Form1->Button7->Caption = "Write Register Page";        //   
                Form1->Button7->Height  = 21;                           //  
                Form1->Button7->Width   = 110;                          //  
                Form1->Button7->Left    = 8;                            //    
                Form1->Button7->Top     = 28;                           //    
                Form1->Button7->Visible = true;                         //   
                Form1->Button8->Caption = "Read Register Page";         //   
                Form1->Button8->Height  = 21;                           //  
                Form1->Button8->Width   = 110;                          //  
                Form1->Button8->Left    = 117;                          //    
                Form1->Button8->Top     = 28;                           //    
                Form1->Button8->Visible = true;                         //   
                Form1->Button9->Caption = "Write Data Memory";          //   
                Form1->Button9->Height  = 21;                           //  
                Form1->Button9->Width   = 110;                          //  
                Form1->Button9->Left    = 8;                            //    
                Form1->Button9->Top     = 48;                           //    
                Form1->Button9->Visible = true;                         //   
                Form1->Button10->Caption = "Read Data Memory";          //   
                Form1->Button10->Height  = 21;                          //  
                Form1->Button10->Width   = 110;                         //  
                Form1->Button10->Left    = 117;                         //    
                Form1->Button10->Top     = 48;                          //    
                Form1->Button10->Visible = true;                        //   
              //  
                Form1->Label3->Caption   = "TA1";                       //   
                Form1->Label3->Height    = 13;                          //  
                Form1->Label3->Width     = 20;                          //  
                Form1->Label3->Left      = 247;                         //    
                Form1->Label3->Top       = 32;                          //    
                Form1->Label3->Visible   = true;                        //   
                Form1->Label4->Caption   = "TA2";                       //   
                Form1->Label4->Height    = 13;                          //  
                Form1->Label4->Width     = 20;                          //  
                Form1->Label4->Left      = 284;                         //    
                Form1->Label4->Top       = 32;                          //    
                Form1->Label4->Visible   = true;                        //   
                Form1->Label5->Caption   = "E/S";                       //   
                Form1->Label5->Height    = 13;                          //  
                Form1->Label5->Width     = 20;                          //  
                Form1->Label5->Left      = 322;                         //    
                Form1->Label5->Top       = 32;                          //    
                Form1->Label5->Visible   = true;                        //   
                Form1->Label6->Caption   = "Test";                      //   
                Form1->Label6->Height    = 13;                          //  
                Form1->Label6->Width     = 25;                          //  
                Form1->Label6->Left      = 358;                         //    
                Form1->Label6->Top       = 32;                          //    
                Form1->Label6->Visible   = true;                        //   
              //  
                Form1->Edit4->Text       = "00";                        //   
                Form1->Edit4->Height     = 21;                          //  
                Form1->Edit4->Width      = 21;                          //  
                Form1->Edit4->Left       = 247;                         //    
                Form1->Edit4->Top        = 48;                          //    
                Form1->Edit4->Visible    = true;                        //   
                Form1->Edit5->Text       = "00";                        //   
                Form1->Edit5->Height     = 21;                          //  
                Form1->Edit5->Width      = 21;                          //  
                Form1->Edit5->Left       = 284;                         //    
                Form1->Edit5->Top        = 48;                          //    
                Form1->Edit5->Visible    = true;                        //   
                Form1->Edit6->Text       = "00";                        //   
                Form1->Edit6->Height     = 21;                          //  
                Form1->Edit6->Width      = 21;                          //  
                Form1->Edit6->Left       = 322;                         //    
                Form1->Edit6->Top        = 48;                          //    
                Form1->Edit6->Visible    = true;                        //   
                Form1->Edit7->Text       = "00";                        //   
                Form1->Edit7->Height     = 21;                          //  
                Form1->Edit7->Width      = 21;                          //  
                Form1->Edit7->Left       = 359;                         //    
                Form1->Edit7->Top        = 48;                          //    
                Form1->Edit7->Visible    = true;                        //   
              //  Panel2
                Form1->Panel2->Height           = 497;                  //  
              //  PageControl1
                Form1->PageControl1->Height     = 302;                  //     
                Form1->PageControl1->Top        = 73;                   //    
                Form1->PageControl1->Visible    = true;                 //   
              //        PageControl1
                Form1->Label7->Caption          = "EEPROM Data Memory:";//   
                Form1->Label7->Top              = 0;                    //    
                Form1->Label7->Visible          = true;                 //   
                Form1->RichEdit1->Height        = 161;                  //  RichEdit1
                Form1->RichEdit1->Top           = 16;                   //    
              InitDataOnForm(1);                                        //  RichEdit1
                Form1->Label8->Caption          = "EEPROM Data Memory:";//   
                Form1->Label8->Top              = 0;                    //    
                Form1->Label8->Visible          = true;                 //   
                Form1->RichEdit2->Height        = 161;                  //  RichEdit2
                Form1->RichEdit2->Top           = 16;                   //    
              InitDataOnForm(2);                                        //  RichEdit2
                Form1->Label9->Caption          = "Registers Page:";    //   
                Form1->Label9->Top              = 184;                  //    
                Form1->Label9->Visible          = true;                 //   
                Form1->RichEdit3->Height        = 25;                   //  RichEdit3
                Form1->RichEdit3->Top           = 200;                  //    
              InitDataOnForm(3);                                        //  RichEdit3
                Form1->Label10->Caption         = "Registers Page:";    //   
                Form1->Label10->Top             = 184;                  //    
                Form1->Label10->Visible         = true;                 //   
                Form1->RichEdit4->Height        = 25;                   //  RichEdit4
                Form1->RichEdit4->Top           = 200;                  //    
              InitDataOnForm(4);                                        //  RichEdit4
                Form1->Label11->Caption         = "Scratchpad:";        //   
                Form1->Label11->Top             = 232;                  //    
                Form1->Label11->Visible         = true;                 //   
                Form1->RichEdit5->Height        = 25;                   //  RichEdit5
                Form1->RichEdit5->Top           = 248;                  //    
              InitDataOnForm(5);                                        //  RichEdit5
                Form1->Label12->Caption         = "Scratchpad:";        //   
                Form1->Label12->Top             = 232;                  //    
                Form1->Label12->Visible         = true;                 //   
                Form1->RichEdit6->Height        = 25;                   //  RichEdit6
                Form1->RichEdit6->Top           = 248;                  //    
              InitDataOnForm(6);                                        //  RichEdit6
                Form1->Label15->Top             = 377;                  //       
                Form1->RichEdit9->Top           = 393;                  //       
                break;
    default:    break;
  }
  CommonVisible();      //       
}
//---------------------------------------------------------------------------
