//---------------------------------------------------------------------------
//      RW1990
//---------------------------------------------------------------------------
#pragma hdrstop
#include "RW1990.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---    ROM (0x33) -----------------------------
//---------------------------------------------------------------------------
// output:      Success
RW1990_OUTPUT_DATA RW1990_ReadROM()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  RW1990_OUTPUT_DATA OutputData;        //   

  OutputData.Success=false;             //   

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Read ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x33;                                  // Read ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM
  for(unsigned int i=0; i<8; i++)                       //    ROM
  { //    
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                              // 
    if(!rd_buf.Size) { SendMsgToLogForm(21);          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    SelectedChip.ROM[i]=rd_buf.Data[0];               //    (  0x0  0xFF)
    Sleep(1);
  }
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------
//---    ROM (0xD5) -------------------------------------
//---------------------------------------------------------------------------
// output:      Success
RW1990_OUTPUT_DATA RW1990_WriteROM()
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  RW1990_OUTPUT_DATA OutputData;        //   
  unsigned int CurrentByte, CurrentBit; //     

  OutputData.Success=false;             //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  / 
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xD1;                                  //  
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    (  0  ) -  
  wr_buf.Size=2;
  wr_buf.Data[0]=0x63;
  wr_buf.Data[1]=0;                                     //     
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);    //  
  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //   
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xD5;                                  //  
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    ROM      10    
  for(unsigned int i=0; i<64; i++)                       //    ROM
  {   CurrentByte=i/8; CurrentBit=i-8*CurrentByte;
      //   
      wr_buf.Size=2;
      wr_buf.Data[0]=0x63;
      wr_buf.Data[1]=(~SelectedChip.ROM[CurrentByte])>>CurrentBit; //    ROM,        
      if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);                 //   
                             LBar->Free();                         //    -
                             ClosePort();
                             return OutputData;
                           }
      Sleep(10);        //     
  }
  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  / 
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xD1;                                  //  
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //    (  1  ) -  
  wr_buf.Size=2;
  wr_buf.Data[0]=0x63;
  wr_buf.Data[1]=1;                                     //     
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);    //  
  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11);          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------
